********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ήήβΥ饰󥸥屿ư (1)
*     Ĥ
*                          
*  99/04/24  ͧ
*      99/05/11 ; 
********************************************************************************
      program lagra1

      parameter(nmax=360,itmax=30)  ! nmax: γҿ, itmax: ֤׻ 
      parameter(dt=1.,istep=10)     ! dt: ֹ(=tend-t), istep: ƥå׿
      parameter(xmin=-200.,xmax=200.,ymin=-100.,ymax=100.)
      parameter(nx=21,ny=11)

      real r(2),work(2,3)
      real x(0:nmax,0:itmax),y(0:nmax,0:itmax)
      real u(nx,ny),v(nx,ny)
      character cdummy*60,ctime*8

      common /const/u0, dudx, dudy, v0, dvdx, dvdy
      external odrkg, fcn
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call glrget('rmiss', rmiss)
      call gllset('lmiss', .true.)

c**** experimental parameters ****c
      open(1,file='expar1.data')
      read(1,*) u0, dudx, dudy,  ! ήuʬ: u = u0 + dudx*x + dudy*y
     +          v0, dvdx, dvdy,  ! ήvʬ: v = v0 + dvdx*x + dvdy*y
     +          cdummy
      close(1)

c**** flow field (u,v) ****c
      delx = (xmax-xmin)/(nx-1)
      dely = (ymax-ymin)/(ny-1)
      do j=1,ny
        do i=1,nx
          xx = xmin + delx*(i-1)
          yy = ymin + dely*(j-1)
          if(i.eq.1 .or. i.eq.nx .or. j.eq.1 .or. j.eq.ny) then
            u(i,j)=rmiss
            v(i,j)=rmiss
          else
            u(i,j) = u0 + dudx*xx + dudy*yy
            v(i,j) = v0 + dvdx*xx + dvdy*yy
          end if
        end do
      end do

c**** initial condition ****c
      t = 0.0
      do n=0,nmax
        theta = 2.*3.14159/nmax       
        x(n,0) = 40.*cos(n*theta)
        y(n,0) = 40.*sin(n*theta)
        if(u0 .gt. 0.) x(n,0) = x(n,0) - 150.
      end do

c**** time-integration ****c
      do i=1,itmax
        tend = t + dt
        do n=0,nmax
          r(1) = x(n,i-1)
          r(2) = y(n,i-1)
          call odrkdu(2, odrkg, fcn, t, tend, istep, r, work)
          x(n,i) = r(1)
          y(n,i) = r(2)
          t = t - tend   !! DCLޥ˥奢MATH2 ODRKDUɤɤͤ뤳
        end do 
      end do  

c**** graph ****c
      call swiset('iwidth',  750)
      call swiset('iheight', 450)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)

      call gropn(1)

      do i=0,itmax
        call grfrm
        call grswnd(xmin, xmax, ymin, ymax)
        call grsvpt(0.15, 0.95,  0.1,  0.5)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', 20., 100.)
        call uxaxdv('t', 20., 100.)
        call uxsttl('b', 'X', 0.0)
        call uyaxdv('l', 20., 100.)
        call uyaxdv('r', 20., 100.)
        call uysttl('l', 'Y', 0.0)

        ctime = 'T='
        write(ctime(3:6),'(f4.1)') i*dt
        call uxsttl('t', ctime, -0.8)

        call ugiset('index', 91)
        call uglset('lnrmal', .false.)
        vfact = 0.002
        call ugrset('xfact1', vfact)
        call ugrset('yfact1', vfact)
        call uglset('lmsg', .false.)
        call ugvect(u, nx, v, nx, nx, ny)

        if(i .ne. 0) then
          call sgspli(81)
          do ipast=0,i-1
            call sgplu(nmax+1, x(0,ipast), y(0,ipast))
          end do  
        end if  

        call sgspmi(21)
        call sgpmu(nmax, x(1,i), y(1,i))
      end do  

      call grcls

      stop
      end
********************************************************************************
      subroutine fcn(n,t,x,dx)

      real x(n),dx(n)

      common /const/u0, dudx, dudy, v0, dvdx, dvdy
*-----+--1---------2---------3---------4---------5---------6---------7-+
      dx(1) = u0 + dudx*x(1) + dudy*x(2)
      dx(2) = v0 + dvdx*x(1) + dvdy*x(2)

      return
      end
********************************************************************************






