********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ήήβΥ饰󥸥屿ư (2)
*     ž
*
*  99/04/24  ͧ
*      99/05/11 ; 
********************************************************************************
      program lagra2
      
      parameter(nmax=480,itmax=30)  ! nmax: γҿ, itmax: ֤׻ 
      parameter(dt=1.,istep=10)     ! dt: ֹ(=tend-t), istep: ƥå׿
      parameter(xmin=-100.,xmax=100.,ymin=-100.,ymax=100.)
      parameter(nx=31,ny=31)
      real r(2),work(2,3)
      real x(0:nmax,0:itmax),y(0:nmax,0:itmax)
      real u(nx,ny),v(nx,ny)
      character cdummy*60,ctime*8

      common /const/omega, redge
      external odrkg, fcn
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call glrget( 'rmiss', rmiss )
      call gllset( 'lmiss', .true. )

c**** experimental parameters ****c
      open(1,file='expar2.data')
      read(1,*) omega,    ! βžγ®: v_tan = r*omega
     +          redge,    ! βžȾ
     +          xoffst,   ! ν xɸ
     +          yoffst,   ! ν yɸ
     +          cdummy
      close(1)

c**** flow field (u,v) ****c
      delx = (xmax-xmin)/(nx-1)
      dely = (ymax-ymin)/(ny-1)
      do j=1,ny
        do i=1,nx
          xx = xmin + delx*(i-1)
          yy = ymin + dely*(j-1)
          if(i.eq.1 .or. i.eq.nx .or. j.eq.1 .or. j.eq.ny) then
            u(i,j)=rmiss
            v(i,j)=rmiss
          else
            rr = sqrt( xx**2 + yy**2 )
            if (rr .eq. 0.0) then
              u(i,j)=rmiss
              v(i,j)=rmiss
            else
              if (rr .le. redge) then
                vtan = rr*omega
              else
                vtan = redge**2 *omega/rr
              end if

              if(yy .ge. 0.) then
                theta =   acos(xx/rr)
              else  
                theta = - acos(xx/rr)
              end if  

              u(i,j) = - vtan*sin(theta)
              v(i,j) =   vtan*cos(theta)
            end if
          end if
        end do
      end do

c**** initial condition ****c
      t = 0.0
      hr = 30.
      do n=1,nmax/4
        dx = 2*hr/(nmax/4)
        x(n         ,0) = - hr + dx*(n-1) + xoffst
        x(n+  nmax/4,0) =   hr            + xoffst
        x(n+2*nmax/4,0) =   hr - dx*(n-1) + xoffst
        x(n+3*nmax/4,0) = - hr            + xoffst
        y(n         ,0) = - hr            + yoffst
        y(n+  nmax/4,0) = - hr + dx*(n-1) + yoffst
        y(n+2*nmax/4,0) =   hr            + yoffst
        y(n+3*nmax/4,0) =   hr - dx*(n-1) + yoffst
      end do
      x(0,0) = x(nmax,0)
      y(0,0) = y(nmax,0)

c**** time-integration ****c
      do i=1,itmax
        tend = t + dt
        do n=0,nmax
          r(1) = x(n,i-1)
          r(2) = y(n,i-1)
          call odrkdu(2, odrkg, fcn, t, tend, istep, r, work)
          x(n,i) = r(1)
          y(n,i) = r(2)
          t = t - tend   !! DCLޥ˥奢MATH2 ODRKDUɤɤͤ뤳
        end do 
      end do  

c**** graph ****c
      call swiset('iwidth',  540)
      call swiset('iheight', 540)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)

      call gropn(1)

      do i=0,itmax
        call grfrm
        call grswnd(xmin, xmax, ymin, ymax)
        call grsvpt(0.18, 0.93, 0.15, 0.90)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', xmax/10., xmax/2.)
        call uxaxdv('t', xmax/10., xmax/2.) 
        call uxsttl('b', 'X', 0.0)
        call uyaxdv('l', ymax/10., ymax/2.)
        call uyaxdv('r', ymax/10., ymax/2.) 
        call uysttl('l', 'Y', 0.0)

        ctime = 'T='
        write(ctime(3:6),'(f4.1)') i*dt
        call uxsttl('t', ctime, -0.8)

        call ugiset('index', 91)
        call uglset('lnrmal', .false.)
        vfact = 0.002
        call ugrset('xfact1', vfact)
        call ugrset('yfact1', vfact)
        call uglset('lmsg', .false.)
        call ugvect(u, nx, v, nx, nx, ny)

        if(i .ne. 0) then
          call sgspli(81)
          do ipast=0,i-1
            call sgplu(nmax+1, x(0,ipast), y(0,ipast))
          end do  
        end if  

        call sgspmi(21)
        call sgpmu(nmax, x(1,i), y(1,i))
      end do  

      call grcls

      stop
      end
********************************************************************************
      subroutine fcn(n,t,x,dx)

      real x(n),dx(n)

      common /const/omega, redge
*-----+--1---------2---------3---------4---------5---------6---------7-+
      r = sqrt( x(1)**2 + x(2)**2 )

      if(r .le. redge) then
        vtan = r*omega
      else
        vtan = redge**2 *omega/r
      end if

      if(x(2) .ge. 0.) then
        theta =   acos(x(1)/r)
      else  
        theta = - acos(x(1)/r)
      end if  

      dx(1) = - vtan*sin(theta)
      dx(2) =   vtan*cos(theta)

      return
      end
********************************************************************************



