********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ήήβΥ饰󥸥屿ư (3)
*     عԥå
*                          
*  99/05/10  ͧ
*      99/05/11 ; 
********************************************************************************
      program lagra3

      parameter(nmax=480,itmax=30)  ! nmax: γҿ, itmax: ֤׻ 
      parameter(dt=0.5,istep=1)     ! dt: ֹ(=tend-t), istep: ƥå׿
      parameter(pi=3.141592)
      parameter(xmin=0.,xmax=2*pi,ymin=0.,ymax=xmax/2)
      parameter(nx=41,ny=21)
      parameter(nx1=17,ny1=9)
      parameter(nx2= 5,ny2=3)

      real r(2),work(2,3)
      real x(0:nmax,0:itmax),y(0:nmax,0:itmax)
      real u(nx,ny),v(nx,ny)
      real rxy1(nx1),rxy2(nx2)
      character cdummy*60,ctime*8,csgi*1
      character cxy2(nx2)*4

      common /const/amp, u0

      external odrkg, fcn
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call glrget( 'rmiss', rmiss )
      call gllset( 'lmiss', .true. )

      amp = 1.

c**** experimental parameters ****c
      open(1,file='expar3.data')
      read(1,*) px,      ! ߤ濴xɸ
     +          py,      ! ߤ濴yɸ
     +          pr,      ! ߤȾ
     +          u0,      ! طʤΰή®
     +          cdummy

c**** flow field (u,v) ****c
      delx = (xmax-xmin)/(nx-1)
      dely = (ymax-ymin)/(ny-1)

      do j=1,ny
        do i=1,nx
          xx = xmin + delx*(i-1)
          yy = ynin + dely*(j-1)
          if(i.eq.1 .or. i.eq.nx .or. j.eq.1 .or. j.eq.ny) then
            u(i,j) = rmiss
            v(i,j) = rmiss
          else
            u(i,j) = - amp*sin(xx)*cos(yy) + u0
            v(i,j) =   amp*cos(xx)*sin(yy)
          end if
        end do
      end do

c**** initial condition ****c
      t = 0.0
      do n=0,nmax
        theta = 2.*pi/nmax       
        x(n,0) = pr*cos(n*theta) + px
        y(n,0) = pr*sin(n*theta) + py
      end do

c**** time-integration ****c
      do i=1,itmax
        tend = t + dt
        do n=0,nmax
          r(1) = x(n,i-1)
          r(2) = y(n,i-1)
          call odrkdu(2, odrkg, fcn, t, tend, istep, r, work)
          x(n,i) = r(1)
          y(n,i) = r(2)
          t = t - tend   !! DCLޥ˥奢MATH2 ODRKDUɤɤͤ뤳
        end do 
      end do  

c**** graph ****c
      call swiset('iwidth',  750)
      call swiset('iheight', 450)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)

c**** setup for uzpack ****c
      axdel1 = (xmax-xmin)/(nx1-1)
      do l=1,nx1
        rxy1(l) = xmin + (l-1)*axdel1
      end do

      axdel2 = (xmax-xmin)/(nx2-1)
      do l=1,nx2
        rxy2(l) = xmin + (l-1)*axdel2
      end do

      cxy2(1) = '0'
      cxy2(2) =        csgi(167) // '/2'
      cxy2(3) =        csgi(167)
      cxy2(4) = '3' // csgi(167) // '/2'
      cxy2(5) = '2' // csgi(167)

      call gropn(1)

      do i=0,itmax
        call grfrm
        call grswnd(xmin, xmax, ymin, ymax)
        call grsvpt(0.15, 0.95,  0.1,  0.5)
        call grstrn(1)
        call grstrf

        call ugiset('index', 91)
        call uglset('lnrmal', .false.)
        vfact = 0.02
        call ugrset('xfact1', vfact)
        call ugrset('yfact1', vfact)
        call uglset('lmsg', .false.)

        call ugvect(u, nx, v, nx, nx, ny)

        if(i .ne. 0) then
          call sgspli(81)
          do ipast=0,i-1
            call sgplu(nmax+1, x(0,ipast), y(0,ipast))
          end do  
        end if  

        call sgspmi(21)
        call sgpmu(nmax, x(1,i), y(1,i))

        call uxaxlb('b', rxy1, nx1, rxy2, cxy2, 4, nx2)
        call uxaxdv('t', pi/8., pi/2.) 
        call uxsttl('b', 'X', 0.0)
        call uyaxlb('l', rxy1, ny1, rxy2, cxy2, 4, ny2)
        call uyaxdv('r', pi/8., pi/2.) 
        call uysttl('l', 'Y', 0.0)

        ctime = 'T='
        write(ctime(3:6),'(f4.1)') i*dt
        call uxsttl('t', ctime, -0.8)
      end do  

      call grcls

      stop
      end
********************************************************************************
      subroutine fcn(n,t,x,dx)

      real x(n), dx(n)

      common /const/amp, u0
*-----+--1---------2---------3---------4---------5---------6---------7-+
      dx(1) = - amp*sin(x(1))*cos(x(2)) + u0
      dx(2) =   amp*cos(x(1))*sin(x(2))

      return
      end
********************************************************************************


