********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      (Lorenz, 1963)
*
*  99/06/21  ⹰
*      99/06/23 ;  
********************************************************************************
      program lore2

      parameter(imax=3,nmax=100000)
      parameter(dt=0.002,istep=1)

      real x(imax),work(3*imax),xp(nmax,imax)
      character cdummy*60

      common /consts/sigma,r,f,g
      external fcn,odrkg
*-----+--1---------2---------3---------4---------5---------6---------7-+
*-- experimental parameters
      open (1,file='expar2.data')
      read (1,*) sigma, r, f, g, (x(i),i=1,3),    ! ѥ᡼Ƚ
     +          cdummy
      close(1)

*-- time integrations
      t = 0.0
      do  n=1,nmax
        call odrkdu(imax, odrkg, fcn, t, t+dt, istep, x, work)
        do i=1,imax
          xp(n,i) = x(i)
        end do
      end do

*-- output
      call graph(nmax, imax, xp)

      end
*-------------------------------------------------------------------------------
      subroutine fcn(imax, t, x, dx)

      real x(imax),dx(imax)

      common /consts/sigma,r,f,g
*-----+--1---------2---------3---------4---------5---------6---------7-+
      dx(1) = - sigma*x(1) + sigma*x(2)
      dx(2) =       r*x(1) -       x(2) - x(1)*x(3)
      dx(3) =                 x(1)*x(2) -  f/g*x(3)

      return
      end
*-------------------------------------------------------------------------------
      subroutine graph(nmax, imax, xp)

      parameter(pi=3.141593)
      parameter(xymin=-35.,xymax=35.,zmin=0.,zmax=60.)
      parameter(vxymi=-0.5,vxyma=0.5,vzmi=0.,vzma=6./7.)
      parameter(xobj=(vxyma+vxymi)/2,yobj=xobj,zobj=(vzma+vzmi)/2)

      real xp(nmax,imax)
      character ct*60,cttl(3)*7,csgi*1

      common /consts/sigma,r,f,g
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call swiset('iwidth', 720)
      call swiset('iheight',520)
      call sglset('lcorner',.false.)
      call uzfact(1.2)

      call gropn(1)

      call slmgn(0., 0., 0., 0.1)
      write(cttl(1),'(A2,f4.1)') csgi(154)//'=', sigma
      write(cttl(2),'(A2,f4.1)') csgi(163)//'=', r
      write(cttl(3),'(A2,I1,A1,I1)') 'b=',int(f),'/',int(g)
      ct = cttl(1) // cttl(2) // cttl(3)
      call slsttl(ct,'t', 1.0, 1.0, 0.015, 1)

      call grfrm

      rinit  =   2.0
      angini = -65.
      zinit  =   1.0
      xeye = rinit*cos(angini*pi/180.)
      yeye = rinit*sin(angini*pi/180.)
      zeye = zinit

      call g3dini(xymin, xymax, xymin, xymax, zmin, zmax,
     +            vxymi, vxyma, vxymi, vxyma, vzmi, vzma,
     +            xeye, yeye, zeye, xobj, yobj, zobj)
     
      call scspli(41)
      call scplu(nmax,xp(1,1),xp(1,2),xp(1,3))

c      call scspms(0.0005)
c      call scspmi(41)
c      call scpmu(nmax,xp(n,1),xp(n,2),xp(n,3))

      call grcls

      return
      end
********************************************************************************


