********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      ǥǥ (Lorenz, 1993; the sled model)
*      3D
*
*  99/06/17 ߷ 
*      99/06/19 ; 
********************************************************************************
      program lski1

      parameter(xmin=  0.0,xmax=25.0,ymin=-12.5,ymax=12.5)
      parameter(zmin=-10.5,zmax= 2.0)
      parameter(nmax=100,mmax=10)
      parameter(dt=0.1,istep=1)

      real x(0:nmax,mmax),y(0:nmax,mmax),z(0:nmax,mmax)
      real u(0:nmax,mmax),v(0:nmax,mmax),w(0:nmax,mmax)
      real xx(6),work(6,3)
      integer icolor(mmax)

      common /const/g,a,b,rk,rl
      external fcn,odrkg
*-----+--1---------2---------3---------4---------5---------6---------7-+
*- ѥ᡼
      g=9.8
      pi=atan(1.0)*4

      a=0.25
      b=0.5
      rk=pi*0.2   ! parameter p in Lorenz(1993)
      rl=pi*0.5
      y0min = 0.0
      dy    = 0.01
      u0    = 2.5
      v0    = 2.0
      do m=1,mmax
        x(0,m) = 0.0
        y(0,m) = y0min + (m-1)*dy
        z(0,m) = - a*x(0,m) - b*cos(x(0,m)*rk) *cos(y(0,m)*rl)
        u(0,m) = u0
        v(0,m) = v0
        w(0,m) = u(0,m)*(-a + b*sin(x(0,m)*rk) *cos(y(0,m)*rl) )
     &         + v(0,m)*(   + b*cos(x(0,m)*rk) *sin(y(0,m)*rl) )
        icolor(m) = 19 + m*(89-19)/mmax
      end do

*- ʬ
      do n=1,nmax
        tend = n*dt
        do m=1,mmax
          t = (n-1)*dt
          xx(1)=x(n-1,m)
          xx(2)=y(n-1,m)
          xx(3)=z(n-1,m)
          xx(4)=u(n-1,m)
          xx(5)=v(n-1,m)
          xx(6)=w(n-1,m)
          call odrkdu(6, odrkg, fcn, t, tend, istep, xx, work)
          x(n,m)=xx(1)
          y(n,m)=xx(2)
          z(n,m)=xx(3)
          u(n,m)=xx(4)
          v(n,m)=xx(5)
          w(n,m)=xx(6)
        end do
      end do

*- ե
      call swiset('iwidth',  540)
      call swiset('iheight', 540)
      call sglset('lcorner',.false.)

      call gropn(1)

      call grfrm
      call scsvpt(-0.5,  0.5, -0.5,  0.5, -0.5,  0.0)
      call scswnd(xmin, xmax, ymin, ymax, zmin, zmax)
      call scseye(2.3, -0.6,  0.8 )
      call scsobj(0.0,  0.0, -0.25)
      call scstrn(1)

      call s3init
      call s3axis
      call s3topo

      do m=1,mmax
        call scspli(icolor(m)*10+3)
        call scplu(nmax+1,x(0,m),y(0,m),z(0,m))
      end do

      call sgcls
      end
********************************************************************************
      subroutine fcn(i,t,x,dx)

      real x(i),dx(i)

      common /const/g,a,b,rk,rl
*-----+--1---------2---------3---------4---------5---------6---------7-+
      pi=atan(1.)*4

      dx(1)=x(4)
      dx(2)=x(5)
      dx(3)=x(6)
      
      sinx = sin(x(1)*rk)
      cosx = cos(x(1)*rk)
      siny = sin(x(2)*rl)
      cosy = cos(x(2)*rl)

      dhdx    = -a + b * rk      * sinx * cosy
      dhdy    =    + b * rl      * cosx * siny
      d2hdx   =    + b * rk**2   * cosx * cosy
      d2hdy   =    + b * rl**2   * cosx * cosy
      d2hdxdy =    - b * rk * rl * sinx * siny

      f = ( g + d2hdx*x(4)**2 + 2.*d2hdxdy*x(4)*x(5) + d2hdy*x(5)**2 )
     &   /( 1 + dhdx**2 + dhdy**2 )

      c = - f*dhdx/x(4)                        ! U = constant
                                               ! is assumed
      dx(4) = 0.                               ! in the sled model
      dx(5) = - f*dhdy - c*x(5)
      dx(6) =   f      - c*x(6) - g

      return
      end
********************************************************************************
      subroutine s3init

      real dx1,dx2,dy1,dy2,dz1,dz2
      character cttlx*30, cttly*30, cttlz*30

      save
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call uzfact(0.9)

      call sgrget('vxmin3', vxmin)
      call sgrget('vxmax3', vxmax)
      call sgrget('vymin3', vymin)
      call sgrget('vymax3', vymax)
      call sgrget('vzmin3', vzmin)
      call sgrget('vzmax3', vzmax)
      call sgrget('uxmin3', xmin)
      call sgrget('uxmax3', xmax)
      call sgrget('uymin3', ymin)
      call sgrget('uymax3', ymax)
      call sgrget('uzmin3', zmin)
      call sgrget('uzmax3', zmax)
      call sgiget('itr3',   itr3)

      dx1 =  5.0
      dx2 = 10.0
      dy1 =  5.0
      dy2 = 10.0
      dz1 =  5.0
      dz2 = 10.0
      px = 0.0
      py = 0.0
      pz = 0.0
      cttlx = 'DOWN-SLOPE DISTANCE'
      cttly = 'CROSS-SLOPE DISTANCE'
      cttlz = 'HEIGHT'

      return
*-----------------------------------------------------------------------
      entry s3axis

*     / x-y plane /
      call sgswnd( xmin,  xmax,  ymin,  ymax)
      call sgsvpt(vxmin, vxmax, vymin, vymax)
      call sgstrn(itr3)
      call sgstrf

      call scspln(1, 2, vzmin)
      call scsprj

      call uzinit
      call uzlset('labelyl', .false.)
      call uzlset('labelyr', .true.)
      call uziset('irotlxb', 1)
      call uziset('irotcxb', 2)
      call uziset('irotlyr', 1)
      call uziset('irotcyr', 1)
      call uxaxdv('b', dx1, dx2)
      call uxaxdv('t', dx1, dx2)
      call uyaxdv('l', dy1, dy2)
      call uyaxdv('r', dy1, dy2)
      call uxsttl('b', cttlx, px)
      call uysttl('r', cttly, py)

*     / y-z plane /
      call sgswnd( ymin,  ymax,  zmin,  zmax)
      call sgsvpt(vymin, vymax, vzmin, vzmax)
      call sgstrn(itr3)
      call sgstrf

      call scspln(2, 3, vxmin)
      call scsprj

      call uzinit
      call uzlset('labelxb', .false.)
      call uzlset('labelyr', .false.)
      call uzlset('labelyl', .true.)
      call uxaxdv('b', dy1, dy2)
      call uxaxdv('t', dy1, dy2)
      call uyaxdv('l', dz1, dz2)
      call uyaxdv('r', dz1, dz2)
      call uysttl('l', cttlz, pz)

*     / x-z plane /
      call sgswnd( xmin,  xmax,  zmin,  zmax)
      call sgsvpt(vxmin, vxmax, vzmin, vzmax)
      call sgstrn(itr3)
      call sgstrf

      call scspln(1, 3, vymax)
      call scsprj

      call uzinit
      call uzlset('labelyl', .false.)
      call uxaxdv('b', dx1, dx2)
      call uxaxdv('t', dx1, dx2)
      call uyaxdv('l', dz1, dz2)
      call uyaxdv('r', dz1, dz2)

*     / 3-d /
      call scswnd( xmin,  xmax,  ymin,  ymax,  zmin,  zmax)
      call scsvpt(vxmin, vxmax, vymin, vymax, vzmin, vzmax)
      call scstrn(itr3)
      call scstrf

      return

      end
********************************************************************************
      subroutine s3topo

      parameter(nxy=100)

      real xx(0:nxy),yy(0:nxy),zz(0:nxy)

      external hxy           ! Ϸι٤Ϳ볰ؿ롼
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call sgrget('uxmin3', xmin)
      call sgrget('uxmax3', xmax)
      call sgrget('uymin3', ymin)
      call sgrget('uymax3', ymax)

      call scspli(91)
      do i=0,nxy
        do j=0,nxy
          xx(j) = xmin + i*(xmax-xmin)/nxy
          yy(j) = ymin + j*(ymax-ymin)/nxy
          call hxy(xx(j), yy(j), zz(j))
        end do
        call scplu(nxy+1, xx, yy, zz)
      end do

      do j=0,nxy
        do i=0,nxy
          xx(i) = xmin + i*(xmax-xmin)/nxy
          yy(i) = ymin + j*(ymax-ymin)/nxy
          call hxy(xx(i), yy(i), zz(i))
        end do
        call scplu(nxy+1, xx, yy, zz)
      end do

      end
********************************************************************************
      subroutine hxy(x,y,z)             ! Ϸι٤Ϳ륵֥롼

      common /const/g,a,b,rk,rl

      z = -a*x - b*cos(x*rk)*cos(y*rl)

      end
********************************************************************************
