********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      ǥǥ (Lorenz, 1993; the sled model)
*     
*
*  99/06/17 ߷ 
*      99/06/19 ; 
********************************************************************************
      program lski3

      parameter(nmax=150,mmax=20)
      parameter(dt=0.2,istep=1)
      parameter(tmin=0.0,tmax=nmax*dt,dmax=1.e2)

      real dist(0:nmax,mmax**2/2),time(0:nmax)
      real xx(6,mmax),work(6,3)
      character cdammy*60

      common /const/g,a,b,rk,rl
      external fcn,odrkg
*-----+--1---------2---------3---------4---------5---------6---------7-+
*- ѥ᡼
      g=9.8
      pi=atan(1.0)*4

      a=0.25
      b=0.5

      rk=pi*0.2   ! parameter p in Lorenz(1993)
      rl=pi*0.5

      open (10,file='expar.data')
      read (10,*) itopo, mnum, y0min, dy, u0, v0, cdammy
      close(10)

      if(mnum .gt. mmax) stop 'mnum must be less than mmax(20)'
      if(mnum .eq. 1)    stop 'mnum must not be 1'
      if(dy   .eq. 0.)   stop 'dy must not be 0.0'

      dmin = 1.e-2*dy

*- 
      time(0)=0.
      do m=1,mnum
        xx(1,m) = 0.0
        xx(2,m) = y0min + dy*(m-1)
        xx(3,m) = - a*xx(1,m) - b*cos(xx(1,m)*rk) *cos(xx(2,m)*rl)
        xx(4,m) = u0
        xx(5,m) = v0
        xx(6,m) = xx(4,m)*(-a + b*sin(xx(1,m)*rk) *cos(xx(2,m)*rl) )
     &          + xx(5,m)*(   + b*cos(xx(1,m)*rk) *sin(xx(2,m)*rl) )
      end do

      mm = 0
      do m1=1,mnum-1
        do m2=m1+1,mnum
          mm = mm + 1
          dist(0,mm) = abs(xx(2,m1)-xx(2,m2))
        end do
      end do
      dist(0,mm+1) = 0.
      do m=1,mm
        dist(0,mm+1) = dist(0,mm+1) + dist(0,m)**2
      end do
      dist(0,mm+1) = sqrt( dist(0,mm+1)/mm )

*- ʬ
      do n=1,nmax
        tend = n*dt
        time(n) = tend
        do m=1,mnum
          t = (n-1)*dt
          call odrkdu(6, odrkg, fcn, t, tend, istep, xx(1,m), work)
        end do

        mm = 0
        do m1=1,mnum-1
          do m2=m1+1,mnum
            mm = mm + 1
            dist(n,mm) = abs(xx(2,m1)-xx(2,m2))
            if(dist(n,mm) .lt. dmin) dist(n,mm) = dmin
          end do
        end do
        dist(n,mm+1) = 0.
        do m=1,mm
          dist(n,mm+1) = dist(n,mm+1) + dist(n,m)**2
        end do
        dist(n,mm+1) = sqrt( dist(n,mm+1)/mm )
      end do

*- ե
      call glrget('rmiss', rmiss)
      call gllset('lmiss', .true.)
      call swiset('iwidth',  720)
      call swiset('iheight', 540)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)
      call uzfact(0.8)

      call gropn(1)

      call grfrm
      call grswnd(tmin, tmax, dmin, dmax)
      call grsvpt(0.15, 0.95, 0.12, 0.68)
      call grstrn(2)
      call grstrf

      call uxaxdv('b', 2., 10.)
      call uxaxdv('t', 2., 10.)
      call uxsttl('b', 'TIME [s]', 0.0) 
      call ulylog('l', 1, 9)
      call ulylog('r', 1, 9)
      call uysttl('l', 'RELATIVE DISTANCE [m]', 0.0)

      call sgspli(91)
      do m=1,mm
        call sgplu(nmax+1,time(0),dist(0,m))
      end do
      call sgspli(43)
      call sgplu(nmax+1,time(0),dist(0,mm+1))
      
      call grcls
      end
********************************************************************************
      subroutine fcn(i,t,x,dx)

      real x(i),dx(i)

      common /const/ g,a,b,rk,rl
*-----+--1---------2---------3---------4---------5---------6---------7-+
      pi=atan(1.)*4

      dx(1)=x(4)
      dx(2)=x(5)
      dx(3)=x(6)
      
      sinx = sin(x(1)*rk)
      cosx = cos(x(1)*rk)
      siny = sin(x(2)*rl)
      cosy = cos(x(2)*rl)

      dhdx    = -a + b * rk      * sinx * cosy
      dhdy    =    + b * rl      * cosx * siny
      d2hdx   =    + b * rk**2   * cosx * cosy
      d2hdy   =    + b * rl**2   * cosx * cosy
      d2hdxdy =    - b * rk * rl * sinx * siny

      f = ( g + d2hdx*x(4)**2 + 2.*d2hdxdy*x(4)*x(5) + d2hdy*x(5)**2 )
     &   /( 1 + dhdx**2 + dhdy**2 )

      c = - f*dhdx/x(4)                        ! U = constant
                                               ! is assumed
      dx(4) = 0.                               ! in the sled model
      dx(5) = - f*dhdy - c*x(5)
      dx(6) =   f      - c*x(6) - g

      return
      end
********************************************************************************
