********************************************************************************
* ɽ ϵήϳ ׻¸
*
*      ǥǥ (Lorenz, 1993; the sled model)
*     
*
*  99/06/17 ߷ 
*      99/06/19 ; 
********************************************************************************
      program lski4

      parameter(ymin=-2.0,ymax=2.0,vmin=-5.0,vmax=5.0)
      parameter(imax=25,mmax=10000)
      parameter(dt=0.25,istep=2,dx=1.0)

      real y(mmax,0:imax),v(mmax,0:imax)
      real xx(6,mmax)
      real work(6,3)
      character cx*28

      common /const/g,a,b,rk,rl
      external fcn,odrkg
*-----+--1---------2---------3---------4---------5---------6---------7-+
*- ѥ᡼
      g=9.8
      pi=atan(1.)*4

      a=0.25
      b=0.5
      rk=pi*0.2   ! parameter p in Lorenz(1993)
      rl=pi*0.5
      iseed=1

*- 
      do m=1,mmax
        xx(1,m) = 0.0
        xx(2,m) = ymin + (ymax-ymin)*rngu1(iseed)
        xx(3,m) = - a*xx(1,m) - b*cos(xx(1,m)*rk) *cos(xx(2,m)*rl)
        xx(4,m) = 4.0
        xx(5,m) = vmin + (vmax-vmin)*rngu1(iseed)
        xx(6,m) = xx(4,m)*(-a + b*sin(xx(1,m)*rk) *cos(xx(2,m)*rl) )
     &          + xx(5,m)*(   + b*cos(xx(1,m)*rk) *sin(xx(2,m)*rl) )
        y(m,0)=xx(2,m)
        v(m,0)=xx(5,m)
      end do

*- ʬ
      write(6,*)'NOW CALCULATING'
      do m=1,mmax
        n=0
        i=1
c        do while(i <= imax)
        do ijk=1,100000
          t    = n*dt
          n    = n+1
          tend = n*dt
          call odrkdu(6, odrkg, fcn, t, tend, istep, xx(1,m), work)
          if(xx(1,m) .eq. i*dx) then
            y(m,i)=xx(2,m)
            v(m,i)=xx(5,m)
            i=i+1
          end if
          if(i .gt. imax) go to 999
        end do

  999   if(mod(m,1000) .eq. 0) then
          write(6,*)'NOW ',m/1000,'/',mmax/1000,' FINISHED'
        end if
      end do

*- ե
      call swiset('iwidth',  540)
      call swiset('iheight', 540)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call uzfact(0.95)
     
      call gropn(1)
      call sgspmi(41)

      do i=0,imax
        call grfrm
        call grswnd(5*ymin, 5*ymax, 1.4*vmin, 1.4*vmax)
        call grsvpt(  0.15,   0.95,     0.12,     0.92)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', 1.0, 5.0)
        call uxaxdv('t', 1.0, 5.0)
        call uxsttl('b', 'CROSS-SLOPE DISTANCE [m]', 0.0)
        call uyaxdv('l', 1.0, 5.0)
        call uyaxdv('r', 1.0, 5.0) 
        call uysttl('l', 'CROSS-SLOPE SPEED [m/s]', 0.0) 
        cx = 'DOWN-SLOPE DISTANCE =      m'
        write(cx(23:26),'(f4.1)') i*dx
        call uxsttl('t', cx , 0.0)

        call sgpmu(mmax, y(1,i), v(1,i))
      end do

      call grcls
      end
********************************************************************************
      subroutine fcn(i,t,x,dx)

      real x(i),dx(i)

      common /const/ g,a,b,rk,rl
*-----+--1---------2---------3---------4---------5---------6---------7-+
      pi=atan(1.)*4

      dx(1)=x(4)
      dx(2)=x(5)
      dx(3)=x(6)
      
      sinx = sin(x(1)*rk)
      cosx = cos(x(1)*rk)
      siny = sin(x(2)*rl)
      cosy = cos(x(2)*rl)

      dhdx    = -a + b * rk      * sinx * cosy
      dhdy    =    + b * rl      * cosx * siny
      d2hdx   =    + b * rk**2   * cosx * cosy
      d2hdy   =    + b * rl**2   * cosx * cosy
      d2hdxdy =    - b * rk * rl * sinx * siny

      f = ( g + d2hdx*x(4)**2 + 2.*d2hdxdy*x(4)*x(5) + d2hdy*x(5)**2 )
     &   /( 1 + dhdx**2 + dhdy**2 )

      c = - f*dhdx/x(4)                        ! U = constant
                                               ! is assumed
      dx(4) = 0.                               ! in the sled model
      dx(5) = - f*dhdy - c*x(5)
      dx(6) =   f      - c*x(6) - g

      return
      end
********************************************************************************
