!------------$BBh(B1$B>O(B <$BLdBj(BII-3> $B%m%l%s%D$N%9%-!<%2%l%s%G%+%*%9(B--------------
program Lorenz_skislope
  integer,parameter :: nmax=600, mmax=20
  real,   parameter :: pi=3.14159265, dt=0.02
  real,   parameter :: xmin=0., xmax=40., ymin=-20., ymax=20.
  real,parameter   :: a=0.25, b=0.5, xleng=10., yleng=4.
  real,dimension(0:nmax,mmax) :: x, y, z, u, v, w
  real,dimension(mmax)        :: dx1, dx2, dx3, dx4, dy1, dy2, dy3, dy4
  real,dimension(mmax)        :: du1, du2, du3, du4, dv1, dv2, dv3, dv4
 !
  write(*,*)'device number?'
  call sgpwsn
  call swlset('lalt',.true.)
  call swlset('lwait',.false.)
  read (*,*) iws
  call gropn(iws)
  !call sldiv('y',4,3)
  call uzfact(0.8)
 ! $B=i4|CM$N@_Dj(B
  x(0,:) = 0.
  y(0,:) = (/(-0.1 + 0.01*ny, ny=1,mmax)/)
  z(0,:) = - a*x(0,:) - b*COS(2.*pi*x(0,:)/xleng)*COS(2.*pi*y(0,:)/yleng)
  u(0,:) = 4.
  v(0,:) = 2.
  w(0,:) = -u(0,:)* a + v(0,:)*(b*(2.*pi/yleng)*SIN(2.*pi*y(0,:)/yleng))
  !call graph

 ! $B?tCM@QJ,!'%k%s%2!2%/%C%?(B
  do i = 0,nmax-1
    call drv(x(i,:),y(i,:),u(i,:),v(i,:),dx1,dy1,du1,dv1)
    call drv(x(i,:)+dx1/2,y(i,:)+dy1/2, &
             & u(i,:)+du1/2,v(i,:)+dv1/2,dx2,dy2,du2,dv2) 
    call drv(x(i,:)+dx2/2,y(i,:)+dy2/2, &
             & u(i,:)+du2/2,v(i,:)+dv2/2,dx3,dy3,du3,dv3) 
    call drv(x(i,:)+dx3, y(i,:)+dy3,  &
             & u(i,:)+du3  ,v(i,:)+dv3  , dx4,dy4,du4,dv4) 
  !
    x(i+1,:) = x(i,:)+(dx1+(dx2+dx3)*2+dx4)/6.
    y(i+1,:) = y(i,:)+(dy1+(dy2+dy3)*2+dy4)/6.
    u(i+1,:) = u(i,:)+(du1+(du2+du3)*2+du4)/6.
    v(i+1,:) = v(i,:)+(dv1+(dv2+dv3)*2+dv4)/6.
   if(mod(i,5)==0 .and. i/=0) then
     call graph
   end if
   end do
   call grcls
!
contains
subroutine graph
  character :: msgt*10
 !
  call grfrm
  call grswnd(ymin,ymax,xmax,xmin)
  call grsvpt(0.2,0.8,0.2,0.8)
  call grstrn(1)
  call grstrf
  call uxaxdv('t',5.,10.)
  call uxaxdv('b',5.,10.)
  call uyaxdv('l',5.,10.)
  call uyaxdv('r',5.,10.)
  do ig=1,mmax
    call uulin(i+2,y(0:i+1,ig),x(0:i+1,ig))
  end do
  !call uumrk(mmax,y(i+1,:),x(i+1,:) )
  call uxsttl('b','CROSS-SLOPE DISTANCE(m)',0.)
  call uysttl('l','DOWN-SLOPE DISTANCE(m)',0.)
  write(msgt,'(a,f7.2)')'t=',dt*(i+1)
  call uxsttl('t',msgt,-0.8)
end subroutine graph
!
subroutine drv(x,y,u,v,dx,dy,du,dv)
  integer,parameter :: mmax=20
  real,parameter   :: g=9.8, c0=0.5 
  real,dimension(mmax),intent(in)  :: x,  y,  u,  v
  real,dimension(mmax),intent(out) :: dx, dy, du, dv
  real,dimension(mmax) :: dhdx, dhdy, d2hdxdx, d2hdydy, d2hdxdy, f
  real :: pix, piy, c(mmax)
 !
  pix = 2.*pi/xleng
  piy = 2.*pi/yleng
 !
  dhdx    = -a + b* pix     *SIN(pix*x)*COS(piy*y)
  dhdy    =      b* piy     *COS(pix*x)*SIN(piy*y)
  d2hdxdx =      b*(pix**2) *COS(pix*x)*COS(piy*y)
  d2hdydy =      b*(piy**2) *COS(pix*x)*COS(piy*y)
  d2hdxdy =    - b* pix*piy *SIN(pix*x)*SIN(piy*y) 
 !
  f = (g+(u**2)*d2hdxdx+2.*u*v*d2hdxdy+(v**2)*d2hdydy)/(1. + dhdx**2 + dhdy**2)
  c = c0*SQRT(1.+ dhdx**2 + dhdy**2)  !:$BB.$5$KHfNc$7$?K`;$NO(B
  !c = - f*dhdx/u                     !:x$BJ}8~$NB.EY$,0lDj$K$J$kK`;$NO(B
 !
  dx = u*dt
  dy = v*dt
  du = (-f*dhdx - c*u)*dt
  dv = (-f*dhdy - c*v)*dt
 !
end subroutine drv
!
end program

