********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     
*     1 x(n+1) = x(n)**2 - c λȯŸ
*
*  93/xx/yy  ʻ
*      99/07/17 ; 
********************************************************************************
      program ec1

      implicit real*8(d)

      parameter(nmax=50,mmax=2*nmax+2,nly=200,jmax=8)
      parameter(xmin=-2.,xmax=2.)
      parameter(axmi=0.5,axma=1.,aymi=0.5,ayma=1.)

      real  x(0:nmax),rn(0:nmax)
      real x2(0:mmax),y2(0:mmax),flx(nly),fly(nly) 
      dimension dc(jmax)
      character cc*4,cx0*5,ct(jmax)*50

      data dc/0.5d0, 1.0d0, 1.30d0, 1.38d0,
     +        1.4d0, 1.5d0, 1.75d0, 2.00d0/
      data ct/'Steady', 'Period-2', 'Period-4', 'Period-8',
     +        'Period-16', 'Chaos', 'Period-3', 'Chaos'/
*-----+--1---------2---------3---------4---------5---------6---------7-+
* give constant
      dx0 = 1.33d0

      call swiset('iwidth',  720)
      call swiset('iheight', 400)
      call sglset('lfull', .true.)
      call sglset('lclip', .true.)
      call sglset('lcntl', .true.)
      call sglset('lcorner', .false.)
      call uzfact(0.8)

      call gropn(1)

      do j=1,jmax
        call kakkak(nmax, x, rn, mmax, x2, y2,
     +              nly, flx, fly, dc(j), dx0)
* fig1: mapping
        call grfrm
        call grswnd(xmin, xmax, xmin, xmax)
        call grsvpt( 0.1,  0.4,  0.1, 0.4)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', axmi,  axma)
        call uxaxdv('t', axmi,  axma)
        call uyaxdv('l', aymi,  ayma)
        call uyaxdv('r', aymi,  ayma)
        call sglnu( xmin,  0.0, xmax,  0.0)
        call sglnu(  0.0, xmin,  0.0, xmax)
        call sglnu( xmin, xmin, xmax, xmax)

        write(cc,'(f4.2)') dc(j)
        call uxsttl('t', 'c = '//cc, -0.8)
        call uxsttl('t',   ' ', -0.8)
        call uxmttl('t', ct(j), -0.8)
        call uxsttl('b', 'X_n"',   0.0)
        call uysttl('l', 'X_n+1"', 0.0)

        call sgspli(23)
        call sgplu(nly, flx, fly)
        call sgspli(91)
        call sgplu(mmax, x2, y2)

* fig2: iterations
        call grfig
        call grswnd(rn(0), rn(nmax), xmin, xmax)
        call grsvpt( 0.50,     0.98,  0.1, 0.4)
        call grstrn(1)
        call grstrf

        call uxaxdv('b', 1., 10.)
        call uxaxdv('t', 1., 10.)
        call uyaxdv('l', aymi, ayma)
        call uyaxdv('r', aymi, ayma)
        write(cx0,'(f4.2)') x(0)
        call uxsttl('t', 'X_0" = '//cx0, -0.8)
        call uxsttl('b', 'n', 0.0)
        call uysttl('l', 'X_n"', 0.0)

        call sgspli(43)
        call sgplu(nmax+1, rn, x)
      end do

      call grcls

      stop
      end
*******************************************************************************
      subroutine kakkak(nmax, x, rn, mmax, x2, y2,
     +                  nly, flx, fly, dc, dx0)

      implicit real*8(d)

      real  x(0:nmax),rn(0:nmax)
      real x2(0:mmax),y2(0:mmax),flx(nly),fly(nly) 
*-----+--1---------2---------3---------4---------5---------6---------7-+
      do n=1,nly
        flx(n) = 4./float(nly-1)*float(n-1) - 2.
        fly(n) = flx(n)**2 - dc
      end do

      dx = dx0
      x(0) = dx
      do n=1,nmax
        dx = dx**2 - dc
         x(n) = dx
        rn(n) = n
      end do

      dx = dx0
      x2(0) = dx
      y2(0) = 0.
      do n=0,nmax
        dx = dx**2 - dc
        x2(2*n+1) = x2(2*n)
        y2(2*n+1) = dx
        x2(2*n+2) = y2(2*n+1)
        y2(2*n+2) = y2(2*n+1)
      end do

      return
      end
********************************************************************************
