C     < Table (linear plot) >
C     Vertical Grooup Velocity Derived Directly from
C     Dipersion Relation of Hough Functions for Given Zonal Wave Number
C     ( Vertical Grooup Velocity - Frequency cross section)
C     (Solve Eigen Function Problem for Frequency.)
C     Use expantion by Legenre assotiated function.
C     Accuracy(OACC) is checked by solving two Matrices of different 
C     truncation MM/MM2.
C
C     Parameters :
C       MM:maximum of (total wave number)-(zonal wave number)
C    +     for calculation 
C       M :zonal wave number
C       H:scale hight,RR:gas const.,DTDZ:dT/dz,OME:omega
C       TB:basic temperature,RN2:N**2
C     Variables :
C       E:eigen values which correspond equivalent deapth.
C    +     associated function for geopotential field.
C       SGM:normalized angular frequency s.t. SGM=1 for semidiurnal mode
C       NS:symmetric(=0) or antisymmetric(=1)
C       NN:dimesion of the matrix of coeficint
C       RMN:nondimensional vertial wave number
C       RM:dimensional vertial wave number
C       HH:equivalent depth, EPS:(4*ome*re)**2/(g*h)
*       (addapted to dcl-5, Jan 2001, Horiouchi -- incomplete)

      IMPLICIT REAL*8(A-H,O-T,V-Z),REAL(U)
      REAL*8 OACC,RE,H,RR,G,DTDZ,RN2
      PARAMETER(MM=75,KMM=3*(MM/2+1),LM=KMM*(KMM+1)/2)
      PARAMETER(M=4,NN1=MM/2+2,JG=300,UMISS=0.,OACC=1D-2)
      PARAMETER(RE=6.37D6,H=7000.D0,RR=287.1D0,G=9.7D0,DTDZ=0D0)
      PARAMETER(LMAX=5,CGZMAX=1D0)
      DIMENSION A(LM),D(KMM),SD(KMM),E(KMM),E2(KMM),ES(3*LMAX)
      DIMENSION UX(3*LMAX,JG),UYP(3*LMAX,JG,0:1),UYN(3*LMAX,JG,0:1)

      CALL SGPWSN
      READ(5,*) IWS

      MM2=0.7*MM
      PI=4*ATAN(1D0)
      OME=2*PI/86400
      F=4*RE*RE*OME*OME/G
      RMN1=0.001D0
      RMN2=60D0
      UXMAX=RMN2
      DX=(RMN2-RMN1)/(JG-1)
      RN=2D0*PI/300
      RN2=RN*RN

      CALL GLPSET('LMISS',.TRUE.)
      CALL GLPSET('RMISS',UMISS)

      DO 10 J=1,JG
        FRAC=1D0*(JG-J)/(JG-1)
        RMN=RMN1+(RMN2-RMN1)*FRAC
        RM=RN/(2*OME*RE)*RMN
        HH=RN2/G/( RM**2+1D0/(4*H*H) )
        EPS=F/HH
        DO 20 IS=0,1
          CALL SETPAR(MM,M,IS,KM,NS,ID)
          NN=(MM+NS-M)/2-NS+1
          CALL MATRIX(A,M,KM,NS,ID,EPS)
          CALL DTRID1(A,KM,D,SD,ICON)
          CALL DTRQL(D,SD,KM,E,KMD,ICON)
          CALL BUBBLE(KMD,E)
          CALL SETPAR(MM2,M,IS,KM2,NS,ID)
          NN2=(MM2+NS-M)/2-NS+1
          CALL MATRIX(A,M,KM2,NS,ID,EPS)
          CALL DTRID1(A,KM2,D,SD,ICON)
          CALL DTRQL(D,SD,KM2,E2,KMD2,ICON)
          CALL BUBBLE(KMD2,E2)
          CALL CHOOSE(KMD,E,KMD2,E2,ES,NC,OACC,EPS,M,LMAX,RMISS)
          CALL SETUXY(3*LMAX,ES ,RMN,UMISS, UX(1,J),
     +         UYP(1,J,IS),UYN(1,J,IS))
   20   CONTINUE
            write(6,*) 'finished ',j,'/',jg
   10 CONTINUE
      CALL CGZDR(3*LMAX,JG,UX,UYP,(4*OME*OME*RE)/RN,DX,CGZMAX)
      CALL CGZDR(3*LMAX,JG,UX,UYN,(4*OME*OME*RE)/RN,DX,CGZMAX)
      CALL GROPEN(IWS)
      CALL SLMGN(0.0,0.0,0.0,0.19)
      CALL SLDIV('Y',3,1)
      CALL TITLE(M)
      CALL SLRAT(0.65,1.0)
      CALL GRAPH(3*LMAX,JG,UX,UYP,UXMAX,0.2)
      CALL OTHAXS( RN/(2*OME*RE),UXMAX,RN2,G,H )
      CALL GYTTL(1)
      CALL GRAPH(3*LMAX,JG,UX,UYN,UXMAX,0.2)
      CALL OTHAXS( RN/(2*OME*RE),UXMAX,RN2,G,H )
      CALL GYTTL(-1)
      CALL GRAPH(3*LMAX,JG,UX,UYN,UXMAX,0.02)
      CALL OTHAXS( RN/(2*OME*RE),UXMAX,RN2,G,H )
      CALL GYTTL(-2)
      CALL GRCLS
 
      STOP
      END
************************************************************************
      SUBROUTINE GROPEN(IWS)
 
      CALL GROPN(IWS)
      CALL GLPSET('MSGLEV',2)
      CALL SGPSET('LFULL',.TRUE.)
      CALL SGPSET('LCNTL',.TRUE.)
      CALL SGPSET('LCORNER',.FALSE.)
      CALL UZPSET('LOFFSET',.TRUE.)
      CALL UZPSET('UXUSER',0.0)
      CALL UZPSET('UYUSER',0.0)
      CALL UDPSET('LMSG',.FALSE.)

      RETURN
      END
************************************************************************
      SUBROUTINE MATRIX(A,M,KM,NS,ID,EPS)
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(KM*(KM+1)/2)
 
      R(N)=-1D0*M/(N*(N+1))
      S(N)=-SQRT(N*(N+1)/EPS)
      T(N)=SQRT(1D0*(N*N-1)*(N*N-M*M)/(4*N*N-1))/N
 
      DO 10 I=1,KM*(KM+1)/2
      A(I)=0
   10 CONTINUE
 
      N=NS
      L=1
      DO 20 K=1,KM
      JR=MOD(K-1-ID,3)
      IF(JR.NE.0) THEN
      A(L)=R(N)
      N=N+1
      END IF
      L=L+K+1
   20 CONTINUE
 
      N=NS+ID
      L=2
      DO 30 K=2,KM
      JS=MOD(K-2-ID,3)
      JT=MOD(K-ID,3)
      IF(JS.EQ.0) THEN
      A(L)=S(N)
      N=N+1
      ELSE IF(JT.EQ.0) THEN
      A(L)=T(N)
      N=N+1
      END IF
      L=L+K+1
   30 CONTINUE
 
      N=NS+2-ID
      L=4
      DO 40 K=3,KM
      JS=MOD(K-2-ID,3)
      IF(JS.EQ.0) THEN
      A(L)=T(N)
      N=N+2
      END IF
      L=L+K+1
   40 CONTINUE
 
      RETURN
      END
************************************************************************
      SUBROUTINE TITLE(M)
 
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER CS*3
 
      CS='s=#'
      WRITE(CS(3:3),'(I1)') M
 
      CALL SLSTTL('Hough Modes '//CS,'T',0.0,0.2,0.03,1)
      CALL SLSTTL('Vertical Group Velocity Derived Directly'
     +     ,'T',0.0,-0.5,0.027,2)
      CALL SLSTTL('from Dispersion Relation','T',0.0,-1.0,0.027,3)
 
      RETURN
      END
************************************************************************
C     sorting by 'awadachi' method

      SUBROUTINE BUBBLE(NN,E)
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION E(NN)
 
   30 CONTINUE
      INDEX=0
      DO 20 N=1,NN-1
      IF(E(N).GT.E(N+1)) THEN
      ED=E(N)
      E(N)=E(N+1)
      E(N+1)=ED
      INDEX=1      
      END IF
   20 CONTINUE
      IF(INDEX.EQ.1) GOTO 30
 
      RETURN
      END
************************************************************************
      SUBROUTINE SETUXY(LMX,E,RM,UMISS, UX,UYP,UYN)
 
      IMPLICIT REAL*8(A-H,O-T,V-Z),REAL(U)
      DIMENSION E(LMX),UX(LMX),UYP(LMX),UYN(LMX)

      DO 10 K=1,LMX
        UX(K)=RM
        UYP(K)=UMISS
        UYN(K)=UMISS
   10 CONTINUE
      DO 20 K=1,LMX
      ED=E(K)
      IF(ED.LT.0D0) THEN
        UYN(K)=-ED
      ELSE IF(ED.GT.0D0) THEN
        UYP(K)=ED
      END IF
   20 CONTINUE
 
      RETURN
      END
************************************************************************
      SUBROUTINE SETUXY2(LL,E ,RM,OME, UX,UY)
 
      IMPLICIT REAL*8(A-H,O-T,V-Z),REAL(U)
      DIMENSION E(LL),UX(LL),UY(LL)

      DO 10 K=1,LL
        UX(K)=RM
        UY(K)=2*OME*E(K)
   10 CONTINUE
 
      RETURN
      END
************************************************************************
      SUBROUTINE GRAPH(KMM,JG,UX,UY,UXMAX,UYMAX)
 
      IMPLICIT REAL*8(A-H,O-T,V-Z),REAL(U)
      DIMENSION UX(KMM,JG),UY(KMM,JG,0:1),ULB(4),USLB(25)
      CHARACTER CSGI*1,CS*20,CEPS*20,CLB(4)*5,CLBD*5

      CS='(2oa/N)k_z"'
      CS(3:3)=CSGI(151)
      CEPS='C_gz"(ms|-1")'
      UXMIN=0.
      UYMIN=0.
 
      CALL GRFRM
      CALL SGLSET('LCLIP',.TRUE.)
      CALL GRSVPT(0.19,0.54,0.43,0.89)
      CALL GRSWND(UXMIN,UXMAX,UYMIN,UYMAX)
      CALL GRSTRN (1)
      CALL GRSTRF
      CALL USDAXS
      CALL UXMTTL('B',CS,0.0)
      CALL UYMTTL('L',CEPS,0.0)
      CALL SGSPMS(0.01)
      CALL SGSPMT(1)
      CALL SGPMU(KMM*JG,UX,UY(1,1,0))
      CALL SGSPMS(0.0025)
      CALL SGSPMT(7)
      CALL SGPMU(KMM*JG,UX,UY(1,1,1))
      RETURN
*====================================================================
c     < other axies scale DM(x_axis) DMY(y-axis) >
      ENTRY OTHAXS(DM,UXMAX,RN2,G,H)
      UDM=DM
      UDV=UXMAX*UDM/6
      CALL UZPGET('XFACT',UF)
      CALL UZPSET('XFACT',UDM)
**      CALL UXSAXS('B')
**      CALL UZFACT(0.68)
**      CALL UXAXDV('B',UDV,2*UDV)
**      CALL UZFACT(1/0.68)
**      CALL UXSTTL('B','k_z" (m|-1")',0.0)
      DO 10 K=1,4
        ULB(K)=2*UDV*(K-1)
        IF(K.NE.1) THEN
        WRITE(CLB(K)(1:4),'(F4.1)') 2*3.141593/ULB(K)/1000.
        ENDIF
   10 CONTINUE
      DO 20 K=1,7
        USLB(K)=UDV*(K-1)
   20 CONTINUE
      CLB(1)=CSGI(189)
      CALL UXSAXS('B')
      CALL UXAXLB('B',USLB,7,ULB,CLB,5,4)
      CALL UXSTTL('B',CSGI(162)//'_z" (km)',0.0)
      DO 30 K=1,4
        ULB(K)=2*UDV*(K-1)
        HH = RN2/G/( (ULB(K))**2+1D0/(4*H*H) ) / 1000D0
        IF(HH.GE.1) THEN
          WRITE(CLB(K)(1:4),'(F4.2)') HH
        ELSE
          WRITE(CLBD(1:5),'(F5.3)') HH
          CLB(K)=CLBD(2:5)
        ENDIF
***        CALL CHVAL('C',REAL(HH),CLB(K))
   30 CONTINUE
      CALL UXSAXS('B')
      CALL UXAXLB('B',USLB,7,ULB,CLB,5,4)
      CALL UXSTTL('B','h (km)',0.0)
      CALL UZPSET('XFACT',UF)
      RETURN
*===========      
      ENTRY GYTTL(IY)
      IF(IY.EQ.1) THEN
        CALL UXMTTL('T','Eastward',0.0)
      ELSE IF(IY.EQ.-1) THEN
        CALL UXMTTL('T','Westward',0.0)
      ELSE
        CALL UXSTTL('T',' ',0.0)
**        CALL UXSTTL('T','Westward(slow)',0.0)
        CALL UXSTTL('T','Westward(magnified)',0.3)
      ENDIF
      RETURN
      END
*********************************************************************
      SUBROUTINE SETPAR(MM,M,IS,KM,NS,ID)
 
      IMPLICIT REAL*8(A-H,O-Z)
 
      IE=MOD(MM-M,2)
      KM=3*((MM-M)/2+1)-(1-IE)*(1+IS)
      ID=IS
      NS=M
 
      IF(M.EQ.0) THEN
      KM=KM-(2-IS)
      ID=1-IS
      NS=M+1
      END IF
 
      RETURN
      END
*******************************************************************
C     < chose reliable eigen values order OACC>
 
      SUBROUTINE CHOOSE(ND1,E1,ND2,E2,A,NC,OACC,EPS,M,LMAX,RMISS)

C     Ei(i=1,2):eigen values (sgm)
C     NC:number of choosed values(output)
C     SGRV:freq. of pure gravity wave
     
      IMPLICIT REAL*8(A-H,O-T,V-Z),REAL(U)
      DIMENSION E1(ND1),E2(ND2),A(3*LMAX)

      IF(ND2.GT.ND1) THEN
        WRITE(6,*) 'ERROR IN SUBROUTINE CHOOSE : ND2 MUST BE .LE. ND1'
        STOP
      ENDIF
      DO 5 N=1,3*LMAX
        A(N)=RMISS
    5   CONTINUE

C     < count number of negative sgm >

      DO 11 N=1,ND1
        IF(E1(N).LT.0) NN1=N
   11 CONTINUE
      DO 12 N=1,ND2
        IF(E2(N).LT.0) NN2=N
   12 CONTINUE

C     < set positive accurate sgm >

      NAP=0
      DO 20 N=1,MIN(ND1-NN1,ND2-NN2)
        A1=ABS(E1(NN1+N))
        A2=ABS(E2(NN2+N))
        ERR=ABS(A1-A2)
        IF(A1.NE.0) THEN
          IF(ERR/A1.LT.OACC) NAP=NAP+1
        ELSE IF(A2.NE.0) THEN
          IF(ERR/A2.LT.OACC) NAP=NAP+1
        ELSE
          NAP=NAP+1
        ENDIF
   20 CONTINUE
      DO 30 N=1,MIN(NAP,LMAX)
        A(N)=E1(NN1+N)
   30 CONTINUE
      NC=NAP

C     < set negative accurate eps >
C     count the numbers of Rosby and Gravity wave and set them:

      SGRV=M/SQRT(EPS)
      NGRV1=0
      DO 61 N=1,NN1
        IF(-E1(N).GE.SGRV) NGRV1=NGRV1+1
   61 CONTINUE
      NGRV2=0
      DO 62 N=1,NN2
        IF(-E2(N).GE.SGRV) NGRV2=NGRV2+1
   62 CONTINUE
      NAG=0
      DO 70 N=1,MIN(NGRV1,NGRV2)
        A1=ABS(E1(NGRV1-N+1))
        A2=ABS(E2(NGRV2-N+1))
        ERR=ABS(A1-A2)
        IF(A1.NE.0) THEN
          IF(ERR/A1.LT.OACC) NAG=NAG+1
        ELSE IF(A2.NE.0) THEN
          IF(ERR/A2.LT.OACC) NAG=NAG+1
        ELSE
          NAG=NAG+1
        ENDIF
   70 CONTINUE
      DO 80 N=1,MIN(NAG,LMAX)
        A(N+LMAX)=E1(NGRV1-N+1)
   80 CONTINUE
      NAR=0
      DO 90 N=1,MIN(NN1-NGRV1,NN2-NGRV2)
        A1=ABS(E1(NGRV1+N))
        A2=ABS(E2(NGRV2+N))
        ERR=ABS(A1-A2)
        IF(A1.NE.0) THEN
          IF(ERR/A1.LT.OACC) NAR=NAR+1
        ELSE IF(A2.NE.0) THEN
          IF(ERR/A2.LT.OACC) NAR=NAR+1
        ELSE
          NAR=NAR+1
        ENDIF
   90 CONTINUE
      DO 100 N=1,MIN(NAR,LMAX)
        A(N+2*LMAX)=E1(NGRV1+N)
  100 CONTINUE
      NC=NAP+NAG+NAR

      RETURN
      END
******************************************************************
C     < calculate vertical velocity directly >

      SUBROUTINE CGZDR(LMX,JG,UX,UY,FACT,DX,CGZMAX)

C     UX : (2*OME*RE/RN)*|RM|
C     UY : freq./(2*OME)
C     FACT:(2*OME)*(2*OME*RE/RN) = (4*OME*OME*RE)/RN
C     DX : increment of ux

      IMPLICIT REAL*8(A-H,O-T,V-Z),REAL(U)
      DIMENSION UX(LMX,JG),UY(LMX,JG,0:1)

      CALL GLPGET('RMISS',UMISS)
      DO 10 IS=0,1
      DO 20 N=1,LMX
      DO 30 J=1,JG-1
      IF(UY(N,J,IS).NE.UMISS .AND. UY(N,J+1,IS).NE.UMISS) THEN
        UY(N,J,IS)=-FACT*(UY(N,J,IS)-UY(N,J+1,IS))/DX
        IF(UY(N,J,IS).GT.CGZMAX) UY(N,J,IS)=UMISS
        IF(UY(N,J,IS).LT.0.0) THEN
          WRITE(6,*) 'WARNING(CGZDR) One negative cgz modified to zero.'
          WRITE(6,*) '               where cgz=',UY(N,J,IS)
          UY(N,J,IS)=UMISS
        ENDIF
      ELSE
        UY(N,J,IS)=UMISS
      ENDIF
   30 CONTINUE
      UY(N,JG,IS)=UMISS      
   20 CONTINUE
   10 CONTINUE

      DO 40 N=1,LMX
      DO 50 J=1,JG-1
        UX(N,J)=UX(N,J)-DX/2.
   50 CONTINUE
   40 CONTINUE
      RETURN
      END
