********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ľ2ǮήΥڥȥǥ롧(Benard-Rayleigh)
*
*  95/01/28   ()
*      99/05/25     (ù)
*      99/05/30 ;  ()
********************************************************************************
*     ڥȥǥѥ֥롼 ʬ, ץ饷, աꥨѴ 
********************************************************************************
*-------------------------------------------------------------------------------
*       ץ饷, ʬͿ롼
*-------------------------------------------------------------------------------
*--- laplacian(mnmn)Ϳ롼 ---
* ̤
      subroutine laplaf(fmn)

      include 'incpa.f'

      real fmn(2*mx+1,ny),gmn(2*mx+1,ny)
      real fmj(2*mx+1,jy-1)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      do n=1,ny
        fmn(1,n) = - fmn(1,n)*(pi*n)**2
        do m=1,mx 
          rmn = (2*pi*m/rlengt)**2 + (pi*n)**2
          fmn(2*m,  n) = - rmn*fmn(2*m,  n)
          fmn(2*m+1,n) = - rmn*fmn(2*m+1,n)
        end do
      end do

      return
*--- laplacianε(mnmn)Ϳ롼 ---
      entry laplab(fmn)

      do n=1,ny
        fmn(1,n) = - fmn(1,n)/(pi*n)**2
        do m=1,mx
          rmn = (2*pi*m/rlengt)**2 + (pi*n)**2
          fmn(2*m,  n) = - fmn(2*m,  n)/rmn
          fmn(2*m+1,n) = - fmn(2*m+1,n)/rmn
        end do
      end do

      return
*--- fmjxʬͿ롼 ---
      entry dfmjdx(fmj)

      do j=1,jy-1
        fmj(1,j) = 0.0
        do m=1,mx
          fmjs = fmj(2*m,j)
          fmj(2*m  ,j) = - 2*pi*m*fmj(2*m+1,j)/rlengt
          fmj(2*m+1,j) =   2*pi*m*fmjs        /rlengt
        end do
      end do

      return
*--- fmnyʬͿ롼 ---
      entry dfmndy(fmn)

      do n=1,ny
        do m=1,2*mx+1
          fmn(m,n) = pi*n*fmn(m,n)
        end do
      end do

      return
*--- mnΥԡ򤹤롼(fmngmn) ---
      entry mncopy(fmn, gmn)

      do n=1,ny
        do m=1,2*mx+1
          gmn(m,n) = fmn(m,n)
        end do
      end do
      
      return
      end
*------------------------------------------------------------------------------
*       աꥨѴͿ롼
*------------------------------------------------------------------------------
      subroutine frini

      include 'incpa.f'
      parameter(jj=2*jy)

      real uij(    ix,jy-1)
      real ukj(2*kx+1,jy-1)
      real ukl(2*kx+1,ly)
      real xa(  jy-1,ix),ya(  jy-1,ix),ta(ix*2)
      real xb(2*kx+1,jj),yb(2*kx+1,jj),tb(jj*2)
      integer ita(5),itb(5)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      call fttrui(ix, ita, ta)
      call fttrui(jj, itb, tb)

      return
*--- աꥨѴ(uij  ukj)
      entry xfrf(uij, ukj)

      do i=1,ix
        do j=1,jy-1
          xa(j,i) = uij(i,j)
        end do
      end do

      call fttruf(jy-1, ix, xa, ya, ita, ta)

      do j=1,jy-1
        ukj(     1,j) = xa(j,1)
        ukj(2*kx  ,j) = xa(j,2)
        ukj(2*kx+1,j) = 0.0
        do k=2,2*kx-1
          ukj(k,j) = xa(j,k+1)
        end do
      end do

      return
*--- աꥨѴ(ukj  uij) (28),(29),(30),(31) ---
      entry xfrb(ukj, uij)

      do j=1,jy-1
        xa(j,1) = ukj(1,j)
        xa(j,2) = ukj(2*kx,j)
        do k=3,2*kx
          xa(j,k) = ukj(k-1,j)
        end do
        do k=2*kx+1,ix
          xa(j,k) = 0.0
        end do
      end do

      call fttrub(jy-1, ix, xa, ya, ita, ta)

      do j=1,jy-1
        do i=1,ix
          uij(i,j) = xa(j,i)
        end do
      end do

      return
*--- աꥨѴ(ukj  ukl) (34) ---
      entry ysinf(ukj, ukl)

      do k=1,2*kx+1
        xb(k,   1) = 0.0
        xb(k,jy+1) = 0.0
        do j=1,jy-1
          xb(k,     j+1) =   ukj(k,j)
          xb(k,2*jy-j+1) = - ukj(k,j)
        end do
      end do

      call fttruf(2*kx+1, jj, xb, yb, itb, tb)

      do k=1,2*kx+1
        do l=1,ly
          ukl(k,l) = - 2*xb(k,2*l+2)
        end do
      end do

      return
*--- աꥨѴ(ukl  ukj) (25),(27) ---
      entry ysinb(ukl, ukj)

      do k=1,2*kx+1
        xb(k,1) = 0.0
        xb(k,2) = 0.0
        do l=1,ly
          xb(k,2*l+1) = 0.
          xb(k,2*l+2) = ukl(k,l)
        end do
        do l=2*ly+3,jj
          xb(k,l) = 0.0
        end do
      end do

      call fttrub(2*kx+1, jj, xb, yb, itb, tb)

      do k=1,2*kx+1
        do j=1,jy-1
          ukj(k,j) = - 0.5*xb(k,j+1)
        end do
      end do

      return
*--- աꥨѴ(ukl  ukj) (24),(26) ---
      entry ycosb(ukl, ukj)

      do k=1,2*kx+1
        xb(k,1) = 0.0
        xb(k,2) = ukl(k,ly)
        do l=1,ly-1
          xb(k,2*l+1) = ukl(k,l)
          xb(k,2*l+2) = 0.0
        end do
        do l=2*ly+1,jj !!!!!! ְ㤤 +2
          xb(k,l) = 0.0
        end do
      end do

      call fttrub(2*kx+1, jj, xb, yb, itb, tb)

      do k=1,2*kx+1
        do j=1,jy-1
          ukj(k,j) = 0.5*xb(k,j+1)
        end do
      end do

      return
      end
*******************************************************************************






