********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ѡˡ(2) ԰
*
*  99/06/03 ߷ 
*      99/06/04 ; 
********************************************************************************
      program inert2

      parameter(pi=3.1416)
      parameter(xmin=-100.,xmax=1900.,ymin=0.,ymax=500.)
      parameter(mmax=3)                           ! mmax: ɽ¸
      parameter(nmax=200)                         ! nmax: ֥ƥå׿
      parameter(jmax=10)                          ! jmax: Ug 
      parameter(dt=0.05)                          ! dt:   ֳִ
                                                  ! ֤ñ̤ [day]
      real x(0:nmax,mmax),y(0:nmax,mmax)          ! Ĺñ̤ [km]
      real p(mmax),q(mmax),ug(0:jmax,mmax)        ! ʿ p [m/s/1000km]
      character csgi*1,cdummy*60,cphi*8,ctime*20, ct*20
      
      common /const/x0,y0,v0
*-----+--1---------2---------3---------4---------5---------6---------7-+
* ¸ѥ᡼ɤ߹
      open(1,file='expar2.data')
      read(1,*) phi, (p(m),q(m),m=1,mmax), dy, cdummy 
      close(1)

      x0  = 0.0
      y00 = (ymax-ymin)/2
      y0  = y00 + dy
      v0  = 0.0
      f   = 2. * (2*pi) * sin(phi*pi/180)

* mmax μ¸
      do m=1,mmax
        ugmin = q(m) - p(m)*ymax/1000
        ugmax = q(m) + p(m)*ymax/1000
        do j=0,jmax
          ug(j,m) = ugmin + (ugmax-ugmin)*j/jmax
        end do

* ñ̤ѹ s => day, m => km
        p(m) = p(m)*8.64e-2                    ! 86400 x 10^-6 = 8.64 x 10^-2 
        q(m) = q(m)*86400/1000                 ! 򤫤 p ñ̤[1/day]
                                               ! q ñ̤[km/day]
        u0   = p(m)*y00 + q(m) + f*dy
        ugy0 = p(m)*y0  + q(m)
* ȯŸ
        if(f .lt. p(m)) then
          do n=0,nmax
            t=dt*n
            call integ1(f, p(m), u0, ugy0, t, x(n,m), y(n,m))
          end do
        else if(f .eq. p(m)) then
          do n=0,nmax
            t=dt*n
            call integ2(f, p(m), u0, ugy0, t, x(n,m), y(n,m))
          end do
        else 
          do n=0,nmax
            t=dt*n
            call integ3(f, p(m), u0, ugy0, t, x(n,m), y(n,m))
          end do
        end if
      end do
  
* graphic initialize
      call swiset('iwidth',  720)
      call swiset('iheight', 540)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)
      call uzfact(0.85)

      call gropn(1)
* animation
      umin=0.
      umax=10.0
      cphi = 'Lat=????'
      write(cphi(5:8),'(f4.1)') phi
      ct = cphi // '|' // csgi(4) // '"'

      do n=0,nmax
	ctime = 'T=????? days'
	write(ctime(3:7),'(f5.2)') n*dt

	call grfrm
        do m=1,mmax
          call grfig
          yvmax =  0.67 - 0.2*(m-1)
          yvmin = yvmax - 0.18
          call grswnd(umin, umax, ymin, ymax)
          call grsvpt(0.13, 0.24, yvmin, yvmax)
          call grstrn(1)
          call grstrf

          if (m .eq. mmax) then
            call uzlset('labelxb',.true.)
          else
            call uzlset('labelxb',.false.)
          end if
          call uzlset('labelyl',.true.)
          call uxaxdv('b', (umax-umin)/4, umax-umin)
          call uyaxdv('l', 100.0, 500.0)
          if(m .eq.    1) call uxsttl('t',        ct,-1.0)
          if(m .eq.    2) call uysttl('l',  'Y [km]', 0.0)
          if(m .eq. mmax) call uxsttl('b', 'Ug[m/s]', 0.0)

          call sgslni(43)
          call sglnu(ug(0,m), ymin, ug(jmax,m), ymax)
          call sglset('lprop', .false.)
          call sgrset('const', 0.01)
          call sgslai(91)
          do j=0,jmax
            ya = ymin + (ymax-ymin)*j/jmax
            if(abs(ug(j,m)) .gt. 1.e-3) call sglau(0., ya, ug(j,m), ya)
          end do

          call grfig
          call grswnd(xmin, xmax,  ymin,  ymax)
          call grsvpt(0.27, 0.99, yvmin, yvmax)
          call grstrn(1)
          call grstrf

          if (m .eq. mmax) then
            call uzlset('labelxb',.true.)
          else
            call uzlset('labelxb',.false.)
          end if
          call uzlset('labelyl',.false.)
          call uxaxdv('b', 100., 500.)
          call uxaxdv('t', 100., 500.) 
          call uyaxdv('l', 100., 500.)
          call uyaxdv('r', 100., 500.) 
          if (m .eq. 1) call uxsttl('t', ctime, 0.8)
          if (m .eq. mmax) call uxsttl('b', 'X [km]', 0.0)

          call sgspli(81)
cc          call sgstnp(80999)

          if(n .ne. 0) then
            call sgplu(n+1, x(0,m), y(0,m))
          end if
          call sgspmi(21)
          call sgspmt(10)
          call sgpmu(1, x(n,m), y(n,m))
        end do
      end do

      call grcls

      end
***********************************************************************
      subroutine integ1(f, p, u0, ugy0, t, x, y)

      common /const/x0,y0,v0

      save
*-----+--1---------2---------3---------4---------5---------6---------7-+
      r = sqrt(f*(p-f))
      x =   0.5*(v0 - f*(u0-ugy0)/r) *exp( r*t) /(p-f)
     &    + 0.5*(v0 + f*(u0-ugy0)/r) *exp(-r*t) /(p-f)
     &              + f*(u0-ugy0)*t /(p-f) 
     &    + u0*t + x0 - v0/(p-f)
      y =   0.5*(v0 - f*(u0-ugy0)/r) *exp( r*t) /r 
     &    - 0.5*(v0 + f*(u0-ugy0)/r) *exp(-r*t) /r 
     &              +   (u0-ugy0)/(p-f) 
     &           + y0

      return
********************************************************************************
      entry integ2(f, p, u0, ugy0, t, x, y)

      x = - (u0-ugy0)*t*(f*t)**2 /6
     &    + 0.5* v0      *f*t**2 + u0*t + x0
      y = - 0.5*(u0-ugy0)*f*t**2 + v0*t + y0 

      return
********************************************************************************
      entry integ3(f, p, u0, ugy0, t, x, y)

      omega = sqrt( f*(f-p) )
      x = (     ( 1 - cos(omega*t))*v0
     &      - f*( t - sin(omega*t)/omega )*(u0 - ugy0) ) /(f-p)
     &    + u0*t + x0
      y =     - ( 1 - cos(omega*t))       *(u0 - ugy0)   /(f-p)
     &           + v0*sin(omega*t)/omega + y0

      return
      end
********************************************************************************
