********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     ѡˡ(1) ϳŪ԰
*                          
*  99/05/20  ͧ
*      99/05/22 ; 
********************************************************************************
      program stasta

      parameter(g=9.8,rho0=1.)             ! rho0: density of parcel
ccc      parameter(ntone=18,ipat0=89,idlev=4) ! , ֹν, ʬ
ccc      parameter(ntone=35,ipat0=89,idlev=2) ! , ֹν, ʬ
      parameter(ntone=69,ipat0=89,idlev=1) ! , ֹν, ʬ
      parameter(nx=2,nz=ntone+1)
      parameter(xmin=0.,xmax=1.,zmin=-1.,zmax=1.)
      parameter(mmax=5)
      parameter(itmax=150)
      parameter(dt=0.2)

      real rho(nx,nz,mmax)                        ! contour
      real drdz(mmax)                             ! ̩ٸ
      real x(0:itmax),z(0:itmax,mmax)             ! parcel ΰ
      complex qai,qa(mmax),qb(mmax),qn(mmax)
      character ctitle*20,ctime*8,cdummy*60,csgi*1
*-----+--1---------2---------3---------4---------5---------6---------7-+
      qai = (0.,1.)
      call gllset('lmiss',.true.)
      call glrget('rmiss',rmiss)

c**** expar.data ****c            
      open(1,file='expar1.data') 
      read(1,*) z0, w0, drdz(1), drdz(2),  ! initial conditions and
     +         drdz(3), drdz(4), drdz(5),  ! vertical gradient of density
     +          cdummy
      close(1)

c****** density field ******c      
      do m=1,mmax
        do j=1,nz
          do i=1,nx
            zz = zmin + (zmax-zmin)*(j-1)/(nz-1)
            rho(i,j,m) = rho0 + drdz(m)*zz
            if(drdz(m) .eq. 0.0) then
              rho(i,j,m) = rho0 + 1.e-5*zz
            end if
          end do
        end do
      end do

c******* tone *******c
      drzmin = rmin(drdz, mmax, 1)
      drzmax = rmax(drdz, mmax, 1)

      prz = 0.7
      if(abs(drzmin) .ge. abs(drzmax)) then
        do m=1,mmax
          if(drdz(m) .eq. drzmin) then
            prmin = rho0 + prz*drdz(m)
            prdel = abs(2.*prz*drdz(m))/ntone
            mmm = m
          end if
        end do
      else
        do m=1,mmax
          if(drdz(m) .eq. drzmax) then
            prmin = rho0 - prz*drdz(m)
            prdel =     2.*prz*drdz(m)/ntone
            mmm = m
          end if
        end do
      end if

      do k=1,ntone
        ipat = (ipat0 - (k-1)*idlev)*1000 + 999
        tlev1 = prmin + (k-1)*prdel
        tlev2 = tlev1 +       prdel
        if(k .eq.     1) tlev1 = rmiss
        if(k .eq. ntone) tlev2 = rmiss
        call uestlv(tlev1, tlev2, ipat)   
      end do

c**** initial condition, Brunt-Vaisala frequency and etc. ****c
      t = 0.
      x(0) = (xmax-xmin)/2
      do m=1,mmax
        z(0,m) = z0
        if(drdz(m) .eq. 0.) then
          qn(m) = rmiss
        else if(drdz(m) .lt. 0.) then
          qn(m) = sqrt( -g*drdz(m)/rho0 )
          qa(m) = 0.5*( z0 - qai*w0/qn(m) )
          qb(m) = 0.5*( z0 + qai*w0/qn(m) )
        else
          qn(m) = sqrt(  g*drdz(m)/rho0 )
          qa(m) = 0.5*( z0 + w0/qn(m) )
          qb(m) = 0.5*( z0 - w0/qn(m) )
        end if  
      end do

c****** calculation ******c
      do i=1,itmax
        t = i*dt
        x(i) = x(0)
        do m=1,mmax
          if(drdz(m) .lt. 0.) then
            z(i,m) = real(  qa(m)*exp( qai*qn(m)*t) 
     +                    + qb(m)*exp(-qai*qn(m)*t) )
          else if(drdz(m) .gt. 0.) then
            z(i,m) = qa(m)*exp(qn(m)*t) + qb(m)*exp(-qn(m)*t)
          else
            z(i,m) = z0 + w0*t
          end if
        end do
      end do

c******************* graph **********************c
      call swiset('iwidth',  720)
      call swiset('iheight', 480)
      call swlset('lalt', .true.)
      call swlset('lwait',.false.)
      call sglset('lcorner',.false.)
      call sglset('lclip',.true.)
      call sglset('lfull',.true.)

      call uzlset('labelxb',.false.)
      call uzfact(0.85)

      call gropn(1)

      vvxmin = 0.12
      vvxmax = 0.85
      vvxdel = (vvxmax - vvxmin)/mmax
      do i=0,itmax
        call uzlset('labelyl', .true.)
        do m=1,mmax
c********* graph m **********c
          if(m .eq. 1) then
            call grfrm
          else
            call grfig
          end if

          vxmin = vvxmin + (m-1)*vvxdel
          vxmax =  vxmin + vvxdel -0.01
          vymin = 0.04
          vymax = 0.50
          call grsvpt(vxmin, vxmax, vymin, vymax)
          call grswnd( xmin,  xmax,  zmin,  zmax)
          call grstrn(1)
          call grstrf

          call uetone(rho(1,1,m), nx, nx, nz)        

          call sgspms(0.03)
          call sgspmt(230)
          indx = ( ipat0 - idlev*(ntone-1)/2 )*10 + 4
          call sgspmi(indx)
          call sgpmu(1, x(i), z(i,m))
          call sgspms(0.033)
          call sgspmt(228)
          call sgspmi(1)
          call sgpmu(1, x(i), z(i,m))

          call uxaxdv('b', xmax, xmax)
          call uxaxdv('t', xmax, xmax) 
          call uyaxdv('l', zmax/5., zmax)
          call uyaxdv('r', zmax/5., zmax) 

          write(ctitle(1:6),'(f6.3)') drdz(m)
          call uxsttl('t', ctitle, 1.0)
          if(m .eq. 1) then
            call uysttl('l', 'HEIGHT', 0.0)
            call uzlset('labelyl', .false.)
            ctitle = 'd' // csgi(168) // '/dz='
            call uxsttl('t', ctitle, -1.0)
            ctime = 'T='
            write(ctime(3:6),'(f4.1)') i*dt
            call uxmttl('t', ctime, 1.0)
          end if
        end do
  
c********* color bar **********c
        call grfig
      
        call grsvpt(0.87, 0.92, vymin,        vymax        )
        call grswnd(xmin, xmax, rho(1,1,mmm), rho(1,nz,mmm))
        call grstrn(1)
        call grstrf

        call uetone(rho(1,1,mmm), nx, nx, nz)        
        call uxaxdv('b', xmax, xmax)
        call uxaxdv('t', xmax, xmax) 
        dyma = abs(drdz(mmm))
        dymi = dyma/5
        call uyaxdv('l', dymi, dyma)
        call uzrset('rsizel1', 0.018)
        call uzlset('labelyr',.true.)
        call uyaxdv('r', dymi, dyma)
        call uzlset('labelyr',.false.)
        ctitle = csgi(168)
        call uxsttl('t', ctitle, 0.0)
      end do

      call grcls

      stop
      end
********************************************************************************




