********************************************************************************
* ɽ ϵήϳ ׻¸
*
*     contour dynamics model without surgery  animation
*     dynamics.f  version 2.52 97/12/6
*     ʱ߱лұ
*
*  97/12/06  μ(رظ ϵʳ칶 β1ǯ)
*      99/05/14 ; 
********************************************************************************
      program contrd

      implicit real*8(d)
      include 'incpa.f'
      dimension dx(2,0:ndmax+2,nring)     ! particle position
      dimension dqjump(nring)             ! vorticity jump
      dimension dqcx(nring),dqr(nring)    ! center position and radius
      integer   nnode(nring)              ! number of nodes
      character cdummy*60,cfname*8
*-----+--1---------2---------3---------4---------5---------6---------7-+
* kringj:  =1 (ʱ߱), =2 (лұ)
      write(*,*) 'input experiment #:'
      write(*,*) '    kringj=1: elliptic vortex'
      write(*,*) '           2: twin vortices'
      write(*,*) 'kringj= ?'
      read(*,*) kringj                    ! number of contour rings with q gap

      if(kringj .eq. 1) then
        kring = 1                         ! number of contour rings to show
        cfname = 'cd1.data'
        open(51,file='expar1.data')
        read(51,*) dqjump(1), dlambd, dpamp, dpm,   ! ʱ߱
     +             cdummy
      else if(kringj .eq. 2) then
        kring = 2
        cfname = 'cd2.data'
        open(51,file='expar2.data')
        read(51,*) dqjump(1), dqcx(1), dqr(1),      ! ѥå1
     +             dqjump(2), dqcx(2), dqr(2),      ! ѥå2
     +             cdummy
         dlambd = 999.9
      else
        stop 'kringj must be 1 or 2'
      end if
      close(51)

* open files & write parameters
      open(61,file=cfname,form='unformatted')
      write(61) kringj, kring, dlambd, dqjump(1)

* set initial node
      dtime     = 0.0d0
      if(kringj .eq. 1) then
        call initia1(kring, nnode, dx, dlambd, dpamp, dpm)
      else
        call initia2(kring, nnode, dx, dqcx, dqr)
      end if

* graphic initialize
      call grfini

* output data into file & graphic animation
      write(61) dtime, nnode, dx
      if(kringj .eq. 1) then
        call anim1(kring, dtime, nnode, dx, dlambd, dqjump(1))
      else
        call anim2(kring, dtime, nnode, dx)
      end if

      do it=1,ntstep
        write(6,*) 'step No.', it
* redistribution of node
        do k=1,kring
          call redist(nnode(k), dx(1,0,k))
        end do

* advection
        distep = ddt/nistep
        do ii=1,nistep
          call dodrkg(kringj, kring, nnode, distep, dx, dqjump)
          dtime = dtime + distep*ii
        end do

* output data into file & graphic animation
        write(61) dtime, nnode, dx
        if(kringj .eq. 1) then
          call anim1(kring, dtime, nnode, dx, dlambd, dqjump(1))
        else
          call anim2(kring, dtime, nnode, dx)
        end if
      end do

      write(6,*) 'calculation is over. press return.'

      call grfcls
      close(61)

      stop
      end
********************************************************************************
      subroutine initia1(kring, nnode, dx, dlambd, dpamp, dpm)

*     setting initial points 

      implicit real*8(d)

      include 'incpa.f'
      dimension dx(2,0:ndmax+2,nring)     ! particle position
      integer   nnode(nring)              ! number of nodes
*-----+--1---------2---------3---------4---------5---------6---------7-+
      nninit = 1000
      call iset(nnode, nring, 1, nninit)   ! Ρɿν

      dpi    = 4.d0*atan(1.0d0) 
      dtheta = 2.d0*dpi/nninit

      do n=1,nninit
        darg = dtheta*n
        dp = (dpamp/dlambd) * cos( dpm*darg ) 
     &       / ( sin(darg)**2 + (cos(darg)/dlambd)**2)
        dx(1,n,1) = cos(darg)        + dp*cos(darg)/dlambd
        dx(2,n,1) = sin(darg)/dlambd - dp*sin(darg)
      end do

      if(kring .ge. 2) then
        do k=2,kring
          do n=1,nninit
            dx(1,n,k) = dx(1,n,1)*(0.3d0*k + 0.7d0)
            dx(2,n,k) = dx(2,n,1)*(0.3d0*k + 0.7d0)
          end do
        end do
      end if

      return
      end
********************************************************************************
      subroutine initia2(kring, nnode, dx, dqcx, dqr)

*     setting initial points 

      implicit real*8(d)

      include 'incpa.f'
      dimension dx(2,0:ndmax+2,nring)     ! particle position
      dimension dqcx(nring),dqr(nring)    ! center position and radius
      integer   nnode(nring)              ! number of nodes
*-----+--1---------2---------3---------4---------5---------6---------7-+
      nninit = 1000
      call iset(nnode, nring, 1, nninit)   ! Ρɿν

      dpi    = 4.d0*atan(1.0d0) 
      dtheta = 2.d0*dpi/nninit
      do n=1,nninit
        darg = n*dtheta
        do k=1,kring
          dx(1,n,k) = cos(darg)*dqr(k) + dqcx(k)
          dx(2,n,k) = sin(darg)*dqr(k)
        end do
      end do

      return
      end
********************************************************************************
      subroutine redist(knode, dy)

*     node redistribution

      implicit real*8(d)

      include 'incpa.f'
      dimension dy(2,0:ndmax+2)      ! particle position for a ring
      dimension dleng(0:ndmax+1)     ! length between x(j+1) and x(j)
      dimension dkappa(ndmax+1)      ! curvature at x(j)
      dimension dinter(3,ndmax)      ! interpolation coefficients
      dimension drho1(ndmax)         ! node density at x(j)
      dimension dxnew(2,ndmax)       ! new position after node redistribution

      integer nndfix(0:ndmax)      ! nodes of fixed points
      integer nfix                   ! number of fixed points
*-----+--1---------2---------3---------4---------5---------6---------7-+
* cyclic part
      do i=1,2
        dy(i,0)       = dy(i,knode)
        dy(i,knode+1) = dy(i,1)
        dy(i,knode+2) = dy(i,2)
      end do

* calculate distance, curvature, interpolation coefficients of nodes
      call intpol(knode, dy, dleng, dkappa, dinter)

* calculate node density
      do n=1,knode
        drho1(n) = drhoc + drho0*(abs(dkappa(n)) + abs(dkappa(n+1)))
      end do

* calculate fixed points
      nfix = 0
      do n=1,knode
        dx13 = (dy(1,n+1) - dy(1,n-1))*(dy(1,n+1) - dy(1,n-1))
     &       + (dy(2,n+1) - dy(2,n-1))*(dy(2,n+1) - dy(2,n-1))
        dx123 = dleng(n)*dleng(n) + dleng(n-1)*dleng(n-1)
        if(dx13 .lt. dx123) then                         ! corner angle < 90deg
          nfix = nfix + 1
          nndfix(nfix) = n
        end if
      end do
      nndfix(0) = 1
      nndfix(nfix+1) = knode+1

* calculate new number of nodes
      nndnew = 1                      ! number of new nodes
      do i=1,nfix+1
* density modification
        if(i.eq.1 .and. nndfix(i).eq.1) goto 10

        dndff = 0.0d0                 ! number of new nodes from fixed to fixed
        do n=nndfix(i-1),nndfix(i)-1
          dndff = dndff + drho1(n)*dleng(n)
        end do

        nndff = nint(dndff+2.0d0)     ! number of new nodes
        do n=nndfix(i-1),nndfix(i)-1
          drho1(n) = drho1(n) * dble(nndff)/dndff        ! modification
        end do

* search new nodes
        dndff = 0.0d0
        iold = nndfix(i-1)            ! posision of old nodes
        do inew=0,nndff-1             ! posision of new nodes
   20     dndff = dndff + drho1(iold)*dleng(iold)
          if(dndff .lt. dble(inew)) then
            iold = iold + 1
            goto 20
          else
            dndff = dndff - drho1(iold)*dleng(iold)
            dfra  = (inew*1.d0-dndff)/(drho1(iold)*dleng(iold))
            dinter3 = dfra*( dinter(1,iold)
     &                       + dfra*( dinter(2,iold)
     &                                + dfra*dinter(3,iold) ) )
            dxnew(1,nndnew+inew) = dy(1,iold)
     &           + dfra   *(  dy(1,iold+1) - dy(1,iold) )
     &           + dinter3*( -dy(2,iold+1) + dy(2,iold) )
            dxnew(2,nndnew+inew) = dy(2,iold)
     &           + dfra   *(  dy(2,iold+1) - dy(2,iold) )
     &           + dinter3*(  dy(1,iold+1) - dy(1,iold) )
          end if
        end do
        nndnew = nndnew + nndff
        write(6,*) nndnew
   10   continue
      end do
      nndnew = nndnew - 1

* replace new nodes
      do n=1,nndnew
        dy(1,n) = dxnew(1,n)
        dy(2,n) = dxnew(2,n)
      end do
      knode = nndnew

      return
      end
********************************************************************************
      subroutine intpol(knode, dy, dleng, dkappa, dinter)

*     interpolation

      implicit real*8(d)

      dimension dy(2,0:knode+2)         ! particle position for a ring
      dimension dleng(0:knode+1)        ! length between x(j+1) and x(j)
      dimension dkappa(knode+1)         ! curvature at x(j)
      dimension dinter(3,knode)         ! interpolation coefficients
      dimension da1(2),da2(2),da3(2)
*-----+--1---------2---------3---------4---------5---------6---------7-+
* calculate distance 1
      do n=0,knode+1
        dleng(n) = (dy(1,n+1) - dy(1,n))**2
     &           + (dy(2,n+1) - dy(2,n))**2
      end do

* calculate curvature
      do n=1,knode+1
        do i=1,2
          da1(i) = dy(i,n)   - dy(i,n-1)
          da2(i) = dy(i,n+1) - dy(i,n)
          da3(i) = dleng(n)*da1(i) + dleng(n-1)*da2(i)
        end do
        dkappa(n) = 2*(da1(1)*da2(2) - da1(2)*da2(1))
     &              /sqrt(da3(1)**2 + da3(2)**2)
      end do

* calculate distance 2
      do n=0,knode+1
        dleng(n) = sqrt(dleng(n))
      end do

* calculate interpolation coefficients
      do n=1,knode
        dinter(1,n) = -dleng(n)*(2.d0*dkappa(n) + dkappa(n+1))/6.d0
        dinter(2,n) =  dleng(n)*      dkappa(n)              /2.d0
        dinter(3,n) =  dleng(n)*(   dkappa(n+1) - dkappa(n))/6.d0
      end do

      return
      end
********************************************************************************
      subroutine dodrkg(kringj, kring, nnode, dt, x, dq)

*     Runge-Kutta-Gill
*     original: dcl5.0  90/10/5  S.SAKAI

      implicit real*8(a-h,o-z)

      include 'incpa.f'
      dimension x   (-1:2*ndmax+4,nring),  dx(2*ndmax,nring)
      dimension xout(-1:2*ndmax+4,nring),work(2*ndmax,nring)
      dimension dq(nringj)
      integer   nnode(nring)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      c1 =  (1.d0 - 1.d0/sqrt(2.d0))*dt
      c2 =  -2.d0 + 3.d0/sqrt(2.d0)
      c3 =   2.d0 -      sqrt(2.d0)
      c4 =  (1.d0 + 1.d0/sqrt(2.d0))*dt
      c5 =  (2.d0 + 3.d0/sqrt(2.d0))/3.
      c6 = -(2.d0 +      sqrt(2.d0))/3.

*--------------------------- 1st step ----------------------------------
      do k=1,kring
        call velclr(2*nnode(k),work(1,k))
        do i=1,kringj
          call fcn(dq(i), nnode(i), x(-1,i),
     &                    nnode(k), x( 1,k), work(1,k))
        end do
      end do

      do k=1,kring
        do i=1,2*nnode(k)
          xout(i,k) = x(i,k) + work(i,k)*dt/2.d0
          dx(i,k)   = work(i,k)
        end do
      end do
*--------------------------- 2nd step ----------------------------------
      do k=1,kring
        call velclr(2*nnode(k),work(1,k))
        do i=1,kringj
          call fcn(dq(i), nnode(i), xout(-1,i),
     &                    nnode(k), xout( 1,k), work(1,k))
        end do
      end do

      do k=1,kring
        do i=1,2*nnode(k)
          xout(i,k) = xout(i,k)  + c1*(work(i,k) - dx(i,k))
          dx(i,k)   = c2*dx(i,k) + c3* work(i,k)
        end do
      end do
*--------------------------- 3rd step ----------------------------------
      do k=1,kring
        call velclr(2*nnode(k),work(1,k))
        do i=1,kringj
          call fcn(dq(i), nnode(i), xout(-1,i),
     &                    nnode(k), xout( 1,k), work(1,k))
        end do
      end do

      do k = 1,kring
        do i=1,2*nnode(k)
          xout(i,k) = xout(i,k)  + c4*(work(i,k) - dx(i,k))
          dx(i,k)   = c5*dx(i,k) + c6* work(i,k)
        end do
      end do
*--------------------------- 4th step ----------------------------------
      do k=1,kring
        call velclr(2*nnode(k),work(1,k))
        do i=1,kringj
          call fcn(dq(i), nnode(i), xout(-1,i),
     &                    nnode(k), xout( 1,k), work(1,k))
        end do
      end do

      do k = 1,kring
        do i=1,2*nnode(k)
          x(i,k) = xout(i,k) + (work(i,k)/6. + dx(i,k))*dt
        end do
      end do
      return
      end
********************************************************************************
      subroutine velclr(num2, dvel)

*     set zero for dvel

      real*8 dvel(1:num2)
*-----+--1---------2---------3---------4---------5---------6---------7-+
      do i=1,num2
        dvel(i) = 0.0d0
      end do

      return
      end
********************************************************************************
      subroutine fcn(dqjump, nnode1, dx1, nnode2, dx2, dvel)

*     calculate velocity

      implicit real*8(a-h,o-z)

      include 'incpa.f'
      parameter(kmax=10)

      dimension dx1(2,0:nnode1+2)        ! calculation point
      dimension dleng(0:ndmax+1)         ! length between x(j+1) and x(j)
      dimension dkappa(ndmax+1)          ! curvature at x(j)
      dimension dinter(3,ndmax)          ! interpolation coefficients
      dimension dx2(2,1:nnode2)
      dimension dvel(2,1:nnode2)         ! velocity
      dimension c(kmax),w(kmax)

* gaussian grids and gaussian weights
      data c /
     $     -0.9739065285171717d+00,
     $     -0.8650633666889845d+00,
     $     -0.6794095682990244d+00,
     $     -0.4333953941292473d+00,
     $     -0.1488743389816312d+00,
     $      0.1488743389816312d+00,
     $      0.4333953941292473d+00,
     $      0.6794095682990244d+00,
     $      0.8650633666889845d+00,
     $      0.9739065285171717d+00 /
      data w /
     $      0.6667134430868799d-01,
     $      0.1494513491505806d+00,
     $      0.2190863625159819d+00,
     $      0.2692667193099963d+00,
     $      0.2955242247147527d+00,
     $      0.2955242247147527d+00,
     $      0.2692667193099963d+00,
     $      0.2190863625159819d+00,
     $      0.1494513491505806d+00,
     $      0.6667134430868799d-01 /
*-----+--1---------2---------3---------4---------5---------6---------7-+
* cyclic
      do i=1,2
        dx1(i,0)        = dx1(i,nnode1)
        dx1(i,nnode1+1) = dx1(i,1)
        dx1(i,nnode1+2) = dx1(i,2)
      end do

* calculate distance, curvature, interpolation coefficients of nodes
      call intpol(nnode1, dx1, dleng, dkappa, dinter)

      dpi = 4*atan(1.0d0)
      hx  = 0.5d0
      p0  = hx
ccc      ddx = (1.0-0.0) / 1.0
ccc      hx = ddx  / 2.

* calculate velocity
      do k=1,kmax
        p = p0 + c(k)*hx
        do i=1,nnode1
          dpa    = dx1(1,i+1) - dx1(1,i)
          dpb    = dx1(2,i+1) - dx1(2,i)
          dpeta  = p*( dinter(1,i) + p*( dinter(2,i) + p*dinter(3,i)))
          dpdash = dinter(1,i)
     &                   + p*( 2.d0*dinter(2,i) + p*3.d0*dinter(3,i))

          dxp1 = dx1(1,i) + p*dpa - dpeta*dpb
          dxp2 = dx1(2,i) + p*dpb + dpeta*dpa
          dpcnst1 = w(k)*dqjump*hx* (dpa - dpdash*dpb) /(2.0d0*dpi)
          dpcnst2 = w(k)*dqjump*hx* (dpb + dpdash*dpa) /(2.0d0*dpi)
          do j=1,nnode2
            dpx1 = dxp1 - dx2(1,j)
            dpx2 = dxp2 - dx2(2,j)
            dplg = -0.5*log(dpx1**2 + dpx2**2)
            dvel(1,j) = dvel(1,j) + dpcnst1*dplg
            dvel(2,j) = dvel(2,j) + dpcnst2*dplg
          end do
        end do
      end do

      return
      end
********************************************************************************



        






