!******************************************************************************
! $BI=Bj(B $BCO5eN.BNNO3X(B $B7W;;5!<B83=8(B
!
!    K-dV$BJ}Dx<0(B
!    $B=i4|CM$,(Bsin$B4X?t$N>l9g(B
!
! $BMzNr(B 01/02/16 $BD9C+@n<B;R(B
!      01// $BM>ED(B $B@.CK(B
!*****************************************************************************
!---------------KdV$BJ}Dx<0(B(sin$B4X?t(B)----------------------
program eq_KdV1
  integer,parameter ::  jmax=200,   & ! $B6u4VJ,2rG=(B
                        nmax=20000, & ! $B;~4V@QJ,2s?t(B
                        intgrph=50, & ! $B%0%i%U$rIA$/4V3V(B
                        nmmax=200     ! $B6KBgCM$rDI@W$9$k2s?t(B
  real,parameter :: pi=3.14159265, dt=0.0002
  real :: u(0:jmax), du1(jmax), du2(jmax), du3(jmax), du4(jmax)
  real :: xj(0:jmax), dx, R 
 !
  write(*,*)'device number?'
  call sgpwsn
  call swlset('lalt',.true.)
  call swlset('lwait',.false.)
  read (*,*) iws
  call gropn(iws)
  call uzfact(0.8)
 !
  dx = 1./jmax
  xj = (/(dx*j,j=0,jmax)/)

 ! $B<B83%Q%i%a!<%?$NFI$_9~$_(B
  open(10,file='eq_KdV_expar1.data')
  read(10,*) u1, &   ! $B%5%$%s4X?t$N?6I}(B
             R       ! $BG4@-%Q%i%a!<%?(B
  close(10)

 ! $B=i4|CM$NBeF~(B
  u(1:) = u1 + u1*SIN(2.*pi*xj(1:))  !$B=i4|CM$r%5%$%s4X?t$K(B
  u(0) = u(jmax)
  call graph

  if(R/=0.) then
    nm = 0   !$B6KBgCM$rDI@W$9$k%5%V%k!<%A%s$r8F$V2s?t$N%+%&%s%H(B
    open(11,file='eq_KdV_Max1.data')
    call max(u(1:))
    nm = nm + 1
  end if 
  !
  do it=1,nmax
    call drv(u(1:),      du1)
    call drv(u(1:)+du1/2,du2)
    call drv(u(1:)+du2/2,du3)
    call drv(u(1:)+du3,  du4)
    u(1:) = u(1:) + (du1+du4+2.*(du2+du3))/6.
    u(0) = u(jmax)
  if(mod(it,intgrph)==0) then
    if(R==0.) then        ! R=0. $B$J$iESCf$GH4$1$k!#(B
      if(it > 2000) then
        write(*,*) 'Floating'
        stop
      end if
    end if
    call graph
    if ((R/=0.) .AND. (nm < nmmax)) then   ! R/=0. $B$N;~!"6KBgCM$rDI@W(B
      call max(u(1:))
      nm = nm + 1
    end if
  end if
  end do
  if(R/=0.) close(11)
  call grcls
 !
contains
subroutine graph
  character :: msgt*10
 !
  call grfrm
  call grswnd(0.,1.,0.,3.5)
  call grsvpt(0.2,0.8,0.2,0.8)
  call grstrn(1)
  call grstrf
  call uxaxdv('t',0.05,0.5)
  call uxaxdv('b',0.05,0.5)
  call uyaxdv('l',0.2,1.)
  call uyaxdv('r',0.2,1.)
  call uulin(jmax+1,xj,u)
  call uxsttl('b','x',0.)
  call uysttl('l','u(x)',0.)
  write(msgt,'(a,f7.4)')'t=',dt*it
  call uxsttl('b',msgt,1.)
end subroutine graph
!
subroutine drv(u,du)
  real,intent(in)  :: u(jmax)
  real,intent(out) :: du(jmax)
 !
  du = -dt*u*(CSHIFT(u,1)-CSHIFT(u,-1))/(2.*dx) &
       -(R*dt/(2.*dx**3))*(CSHIFT(u,2)-2.*CSHIFT(u,1) &
       +2.*CSHIFT(u,-1)-CSHIFT(u,-2))
 !
end subroutine drv
!----------$B2r$N6KBgCM$rDI@W$9$k(B $BG[Ns$NBg$-$5$r8GDj(B-------------------
subroutine max(u) 
  integer,parameter :: imax=10 !$B6KBgCM$N:GBg?t(B
  real,intent(in)  :: u(jmax)
  real :: aumax, epsilon
  real :: difup(jmax), difum(jmax), umaxd(jmax)
  integer :: jumax(imax)
  integer :: isign(jmax), isignmax(jmax)
 !
  aumax = MAXVAL(u)
  epsilon = aumax/8.
 !
  difup = CSHIFT(u,1)  - u
  difum = u - CSHIFT(u,-1)
 ! 
  do id=1,jmax
    if((difup(id)*difum(id)<0.).AND.(difup(id)<difum(id))) then
      isign(id) = id
    else
      isign(id) = 0
    end if
  end do
 !
  n = 0
  do isu=1,jmax
    if(isign(isu)/=0) then
      if(u(isu)>epsilon) then
        isignmax(isu) = isu
        umaxd(isu)   = u(isu)
        n = n+1
      else
        isignmax(isu) = 0
        umaxd(isu)   = 0.
      end if
    else
      isignmax(isu) = 0
      umaxd(isu)   = 0.
    end if 
  end do
  if(n>imax) then
    print *,'error : too many umaxs'
    stop 
  end if
 !
  do in=1,n
    do ixm=1,jmax
      if(umaxd(ixm)==maxval(umaxd)) then
        jumax(in)   = ixm
        umaxd(ixm) = 0.
        exit
      end if
    end do
  end do
  jumax(n+1:) = -99
 !
  write(11,*) it*dt, jumax
 !
end subroutine max  
!
end program




