!******************************************************************************
! $BI=Bj(B $BCO5eN.BNNO3X(B $B7W;;5!<B83=8(B
!
!    K-dV$BJ}Dx<0(B
!    $B=i4|CM$,AP6J@~4X?t$N>l9g(B
!
! $BMzNr(B 01/02/16 $BD9C+@n<B;R(B
!      01// $BM>ED(B $B@.CK(B
!*****************************************************************************
!---------------KdV$BJ}Dx<0(B($BAP6J@~4X?t(B)----------------------
program eq_KdV2
  integer,parameter :: jmax=200,   & ! $B6u4VJ,2rG=(B
                       nmax=20000, & ! $B;~4V@QJ,2s?t(B
                       intgrph=50, & ! $B%0%i%U$rIA$/4V3V(B
                       nmmax=100     ! $B6KBgCM$rDI@W$9$k2s?t(B
  real,parameter :: pi=3.14159265, dt=0.00002, R=0.15
  real :: u(0:jmax), du1(jmax), du2(jmax), du3(jmax), du4(jmax)
  real :: xj(0:jmax), xjgrph(0:jmax) 
  real :: d1, d2, dx, dxgrph
 !
  !write(*,*)'device number?'
  call sgpwsn
  call swlset('lalt',.true.)
  call swlset('lwait',.false.)
  !read (*,*) iws
  !call gropn(iws)
  call gropn(1)
  !call sldiv('y',4,3)
  call uzfact(0.8)
 !
  dx = pi/jmax
  xj = (/(dx*j,j=0,jmax)/)
 !
  dxgrph = 1./jmax
  xjgrph = (/(dxgrph*jj,jj=0,jmax)/)

 ! $B<B83%Q%i%a!<%?$NFI$_9~$_(B
  open(10,file='eq_KdV_expar2.data')
  read(10,*) u1,  &   ! $B;3$N9b$5(B($B9b$$J}(B)
             u2       ! $B;3$N9b$5(B($BDc$$J}(B)
  close(10)

 ! $B=i4|CM$NBeF~(B
    ! $BAP6J@~4X?t(B
     d1 = SQRT(12.*R/u1)
     d2 = SQRT(12.*R/u2)
     u(1:) = u1/COSH((xj(1:)-(pi/4))/d1)**2+u2/COSH((xj(1:)-(pi/2))/d2)**2
  u(0) = u(jmax)

  nm = 0 !$B6KBgCM$rDI@W$9$k%5%V%k!<%A%s$r8F$V2s?t$N%+%&%s%H(B

  open(11,file='eq_KdV_Max2.data')
  call graph
  call max(u(1:))
  nm = nm + 1 
  !
  do it=1,nmax
    call drv(u(1:),      du1)
    call drv(u(1:)+du1/2,du2)
    call drv(u(1:)+du2/2,du3)
    call drv(u(1:)+du3,  du4)
    u(1:) = u(1:) + (du1+du4+2.*(du2+du3))/6.
    u(0) = u(jmax)
  if(mod(it,intgrph)==0) then
    call graph
    if (nm < nmmax) then
      call max(u(1:))
      nm = nm + 1
    end if
  end if
  end do
  close(11)
  call grcls
 !
contains
subroutine graph
  character :: msgt*10
 !
  call grfrm
  call grswnd(0.,1.,0.,200.)
  call grsvpt(0.2,0.8,0.2,0.8)
  call grstrn(1)
  call grstrf
  call uxaxdv('t',0.05,0.5)
  call uxaxdv('b',0.05,0.5)
  call uyaxdv('l',10.,50.)
  call uyaxdv('r',10.,50.)
  call uulin(jmax+1,xjgrph,u)
  call uxsttl('b','x',0.)
  call uysttl('l','u(x)',0.)
  write(msgt,'(a,f7.4)')'t=',dt*it
  call uxsttl('b',msgt,1.)
end subroutine graph
!
subroutine drv(u,du)
  real,intent(in)  :: u(jmax)
  real,intent(out) :: du(jmax)
 !
  du = -dt*u*(CSHIFT(u,1)-CSHIFT(u,-1))/(2.*dx) &
       -(R*dt/(2.*dx**3))*(CSHIFT(u,2)-2.*CSHIFT(u,1) &
       +2.*CSHIFT(u,-1)-CSHIFT(u,-2))
 !
end subroutine drv
!----------$B2r$N6KBgCM$rDI@W$9$k(B $BG[Ns$NBg$-$5$r8GDj(B-------------------
subroutine max(u) 
  integer,parameter :: imax=10
  real,intent(in)  :: u(jmax)
  real :: aumax, epsilon
  real :: difup(jmax), difum(jmax), umaxd(jmax)
  integer :: jumax(imax)
  integer :: isign(jmax), isignmax(jmax)
 !
  aumax = MAXVAL(u)
  epsilon = aumax/8.
 !
  difup = CSHIFT(u,1)  - u
  difum = u - CSHIFT(u,-1)
 ! 
  do id=1,jmax
    if((difup(id)*difum(id)<0.).AND.(difup(id)<difum(id))) then
      isign(id) = id
    else
      isign(id) = 0
    end if
  end do
 !
  n = 0
  do isu=1,jmax
    if(isign(isu)/=0) then
      if(u(isu)>epsilon) then
        isignmax(isu) = isu
        umaxd(isu)   = u(isu)
        n = n+1
      else
        isignmax(isu) = 0
        umaxd(isu)   = 0.
      end if
    else
      isignmax(isu) = 0
      umaxd(isu)   = 0.
    end if 
  end do
  if(n>imax) then
    print *,'error : too many umaxs'
    stop 
  end if
 !
  do in=1,n
    do ixm=1,jmax
      if(umaxd(ixm)==maxval(umaxd)) then
        jumax(in)   = ixm
        umaxd(ixm) = 0.
        exit
      end if
    end do
  end do
  jumax(n+1:) = -99
 !
  write(11,*) it*dt, jumax
 !
end subroutine max  
!
end program




